/* Copyright 2019 Ling Zhang

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License. */

Object.defineProperty(exports,"__esModule",{value:!0});var e=require("@agentframework/container"),t=require("@agentframework/domain"),o=require("@agentframework/utils"),r=require("lodash"),n=require("@agentframework/web"),i=require("@agentframework/data"),a=require("url"),s=require("querystring"),l=require("node-fetch"),d=function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}(l),c=require("path"),p=require("crypto"),u=require("@agentframework/core");class AuthenticationSettings extends e.Settings{constructor(){super(...arguments),this.WEB_SIGNIN_PATH="/authentication/signin",this.WEB_SIGNIN_SUCCESS_PATH="/authentication/validate",this.WEB_SIGNIN_FAILED_PATH="/authentication/failed",this.WEB_ACCESS_DENIED_PATH="/authentication/access_denied",this.WEB_SIGNOUT_PATH="/authentication/signout",this.WEB_SIGNOUT_COMPLETE_PATH="/"}}function __decorate(e,t,o,r){var n,i=arguments.length,a=i<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,o):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,o,r);else for(var s=e.length-1;s>=0;s--)(n=e[s])&&(a=(i<3?n(a):i>3?n(t,o,a):n(t,o))||a);return i>3&&a&&Object.defineProperty(t,o,a),a}function __metadata(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}exports.SessionService=class SessionService{async CreateSession(e,t){const o={...t,session:this.CreateNewSessionId(e),token:this.CreateNewTokenId(e)};return this.IdentityService.setIdentityData(e,o),Promise.resolve(o)}async ExtendSessionToken(e,t,o){if(e.identity.session!==t)throw new n.BadRequestError("UnableToUpdateOtherSession");if(e.identity.token!==o)throw new n.BadRequestError("UnableToUpdateOtherToken");const r=this.IdentityService.getIdentityData(e);if(!r)throw new n.BadRequestError("NoSessionDataToExtend");return r.token=this.CreateNewTokenId(e),this.IdentityService.setIdentityData(e,r),r.token}async UpdateSession(e,t,o){if(e.identity.session!==t)throw new n.BadRequestError("UnableToUpdateOtherSession");const r=this.IdentityService.getIdentityData(e);if(r){const t=this.CreateNewTokenId(e);r.token=t,o&&o.profile&&(r.profile=o.profile),this.IdentityService.setIdentityData(e,r)}return r}async TerminateSession(e,t,o){return t===e.identity.session&&this.IdentityService.clearIdentityData(e),!0}CreateNewSessionId(t){return t.construct(e.Id,[],!0).toHexString()}CreateNewTokenId(t){const o=t.settings.WEB_TOKEN_EXPIRES_IN_MILLISECONDS,r=Date.now()+o;return t.construct(e.Id,[r],!0).toHexString()}},__decorate([t.singleton(),__metadata("design:type",n.WebRequestIdentityService)],exports.SessionService.prototype,"IdentityService",void 0),exports.SessionService=__decorate([t.extensible()],exports.SessionService),exports.AuthenticationService=class AuthenticationService{async IsAuthenticated(e){const t=e.identity.token,r=e.identity.session;if(!t||!r)return!1;const n=o.GetTimestamp(t);return!isNaN(n)&&(n>Date.now()||!(n+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS<Date.now())&&this.Sessions.ExtendSessionToken(e,r,t).then(()=>!0).catch(t=>(e.logger.warn(t,`Failed to extend session ${r}`),!1)))}async Authenticate(e,t,n){const i=e.identity;if(e.state.new_device_id)throw new Error("Unable to authenticate without cookie support at client side");i.session&&!o.IsExpired(i.token)&&(e.settings.DEBUG&&e.logger.debug({session:i.session},"Automatically log out for incoming authentication"),await this.Sessions.TerminateSession(e,i.session,"Re-authenticate"));const a={roles:n?r.intersection(t.roles||[],n):t.roles||[],groups:t.groups||[],profile:{_id:t._id.toHexString(),displayName:t.displayName,displayImageURL:t.displayImageURL}};return t.timezone&&t.timezone!==e.settings.TIMEZONE&&(a.timezone=t.timezone),t.locale&&t.locale!==e.settings.LOCALE&&(a.timezone=t.locale),t.currency&&t.currency!==e.settings.CURRENCY&&(a.timezone=t.currency),t.theme&&t.theme!==e.settings.THEME&&(a.timezone=t.theme),this.Sessions.CreateSession(e,a)}async GetStatus(e){const t=await this.IsAuthenticated(e),r=e.identity;let n,i;return t&&(n={issue:o.GetTimestamp(r.session),type:2},r.profile&&(i={id:r.profile.id,username:r.profile.username,displayName:r.profile.displayName,displayImageURL:r.profile.displayImageURL})),i||(i={displayName:"Guest"}),i.roles=r.roles,i.groups=r.groups,r.timezone!==e.settings.TIMEZONE&&(i.timezone=r.timezone),r.locale!==e.settings.LOCALE&&(i.locale=r.locale),r.currency!==e.settings.CURRENCY&&(i.currency=r.currency),r.theme!==e.settings.THEME&&(i.theme=r.theme),{auth:t,session:n,profile:i}}async Update(e,t){const o=t._id.toHexString();if(e.identity.user!==o)throw new Error("Unable to update signed in user to another user");return this.Sessions.UpdateSession(e,o,{timezone:t.timezone!==e.settings.TIMEZONE?t.timezone:void 0,locale:t.locale!==e.settings.LOCALE?t.locale:void 0,currency:t.currency!==e.settings.CURRENCY?t.currency:void 0,theme:t.theme!==e.settings.THEME?t.theme:void 0,roles:t.roles,groups:t.groups,profile:{_id:o,displayName:t.displayName,displayImageURL:t.displayImageURL}}).then(()=>!0).catch(()=>!1)}async SignOut(e,t="SignOut"){return!!e.identity.session&&this.Sessions.TerminateSession(e,e.identity.session,t)}},__decorate([t.singleton(),__metadata("design:type",exports.SessionService)],exports.AuthenticationService.prototype,"Sessions",void 0),exports.AuthenticationService=__decorate([t.extensible()],exports.AuthenticationService);let g=class UserModel extends i.Model{};g=__decorate([i.model("user")],g);class UserCollection extends i.DocumentCollection{constructor(){super(g)}}exports.BasicAuthenticationController=class BasicAuthenticationController{async SignUp(e){let{displayName:t,id:o,password:r}=await e.json();if(!o)throw new n.BadRequestError("MissingUserId");if("string"!=typeof o)throw new n.BadRequestError("InvalidUserId");if(!r)throw new n.BadRequestError("MissingUserPassword");if("string"!=typeof r)throw new n.BadRequestError("InvalidUserPassword");if("string"!=typeof t)throw new n.BadRequestError("InvalidDisplayName");if(r){r=require("bcryptjs").hashSync(r,10)}return(await e.resolve(UserCollection)).insertOne(o,{displayName:t,password:r})}async SignIn(e){const{id:t,password:o}=await e.json();if(!t)throw new n.AuthenticationError("MissingUserId");if("string"!=typeof t)throw new n.AuthenticationError("InvalidUserId");if(!o)throw new n.AuthenticationError("MissingUserPassword");if("string"!=typeof o)throw new n.AuthenticationError("InvalidUserPassword");const r=e.construct(AuthenticationSettings),i=await e.resolve(UserCollection),a=await i.getOne(t);if(!a)throw new n.AuthenticationError("UserNotFound");if(!require("bcryptjs").compareSync(o,a.password))throw new n.AuthenticationError("IncorrectUserPassword");return this.Authenticator.Authenticate(e.req,a).then(t=>{if(t){const t=r.WEB_SIGNIN_SUCCESS_PATH;if(t)return e.redirect(t)}else{const t=r.WEB_SIGNIN_FAILED_PATH;if(t)return e.redirect(t)}}).catch(e=>{throw new n.AuthenticationError(e)})}},__decorate([t.singleton(),__metadata("design:type",exports.AuthenticationService)],exports.BasicAuthenticationController.prototype,"Authenticator",void 0),__decorate([n.method("POST","/signup"),__metadata("design:type",Function),__metadata("design:paramtypes",[n.WebContext]),__metadata("design:returntype",Promise)],exports.BasicAuthenticationController.prototype,"SignUp",null),__decorate([n.method("POST","/signin"),__metadata("design:type",Function),__metadata("design:paramtypes",[n.WebContext]),__metadata("design:returntype",Promise)],exports.BasicAuthenticationController.prototype,"SignIn",null),exports.BasicAuthenticationController=__decorate([n.controller("/api/auth")],exports.BasicAuthenticationController),exports.AuthenticationController=class AuthenticationController{async Status(e){return this.Authenticator.GetStatus(e.req)}async SignOut(e){await this.Authenticator.SignOut(e.req);const t=e.construct(AuthenticationSettings).WEB_SIGNOUT_COMPLETE_PATH;if(t)return e.redirect(t);const o=e.settings.HOME_URL;if(o)return e.redirect(o);const r=e.settings.PUBLIC_URL;return r?e.redirect(r):void 0}},__decorate([t.singleton(),__metadata("design:type",exports.AuthenticationService)],exports.AuthenticationController.prototype,"Authenticator",void 0),__decorate([n.method("GET","/auth/status"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],exports.AuthenticationController.prototype,"Status",null),__decorate([n.method("GET","/signout"),__metadata("design:type",Function),__metadata("design:paramtypes",[n.WebContext]),__metadata("design:returntype",Promise)],exports.AuthenticationController.prototype,"SignOut",null),exports.AuthenticationController=__decorate([n.controller("/api")],exports.AuthenticationController);let h=class EmailModel extends i.Model{};h=__decorate([i.model("email")],h);class EmailCollection extends i.DocumentCollection{constructor(){super(h)}}class WebFoundationService extends e.Resolvable{}class WebFoundationSettings extends n.WebSettings{constructor(){super(...arguments),this.WEB_INVITATION_EXPIRES_IN_MILLISECONDS=12096e5,this.WEB_EMAIL_VERIFICATION_RESEND_INTERVAL_IN_MILLISECONDS=6e4,this.WEB_EMAIL_VERIFICATION_EXPIRES_IN_MILLISECONDS=216e5}}class UserService extends WebFoundationService{async findOneById(e,t){return(await e.resolve(UserCollection)).getOne(t)}async isEmailBeenUsed(e,t){const r=await e.resolve(EmailCollection),n=o.CreateHashedId(t.trim().toLowerCase());return r.getOne(n).then(e=>!!e)}async isMobileExists(e,t){return!1}async findUserFromEmail(t,r){const n=await t.resolve(EmailCollection),i=o.CreateHashedId(r.trim().toLowerCase()),a=await n.getOne(i);if(a&&a.user)return(await t.resolve(UserCollection)).getOne(new e.Id(a.user))}async findOrCreateUserFromExternalUser(e,t){const r=await e.resolve(UserCollection),n=await e.resolve(EmailCollection),i=t._id,a=await r.getOne(i);if(a)return a;if(t.user){const e=await r.getOne(t.user);if(e)return e}const s={displayName:t.displayName,displayImageURL:t.displayImageURL||"",roles:["user"]};if(t.email&&t.emailCertified){const o=e.construct(WebFoundationSettings).ADMIN_EMAIL;o&&"string"==typeof o&&t.email===o&&s.roles.push("admin")}t.locale&&(s.locale=t.locale);const l=await r.insertOne(i,s);if(!l)throw new Error("Unable to create external user");if(t.email&&t.emailCertified){const r=o.CreateHashedId(t.email.trim().toLowerCase()),i=new h;i.name=t.email,i.displayName=t.displayName,i.user=l._id.toHexString(),await n.insertOne(r,i)||e.logger.warn({user:l._id,email:i.name})}return l}}class CurrentUser extends g{static async[t.ClassInitializer](t){if(!(t instanceof n.WebRequest))throw new Error("CurrentUser is only resolvable from ctx scope");const o=t.identity.user;if(o&&e.Id.IsValid(o))return t.resolve(UserService).then(e=>e.findOneById(t,o).then(e=>{if(!e)throw new Error("NoCurrentUser");return Reflect.setPrototypeOf(e,CurrentUser.prototype),e}));throw new Error("NoCurrentUser")}}class WebFoundationController extends e.Resolvable{getFailureURL(e,t){return e.logger.error(t),"/#"+e.construct(AuthenticationSettings).WEB_SIGNIN_FAILED_PATH}}let _=class ExternalUserModel extends i.Model{};_=__decorate([i.model("external_user")],_);class ExternalUserCollection extends i.DocumentCollection{constructor(){super(_)}}let m=class ExternalTokenModel extends i.Model{};m=__decorate([i.model("external_token")],m);class ExternalTokenCollection extends i.DocumentCollection{constructor(){super(m)}}class ExternalUserService extends WebFoundationService{async updateToken(e,t,o){return(await e.resolve(ExternalTokenCollection)).replaceOne(o._id,t)}async connectUser(e,t,o){return(await e.resolve(ExternalUserCollection)).mergeOne(t._id,{user:o._id})}async findOrCreateExternalUser(e,t){const r=await e.resolve(ExternalUserCollection),n=o.CreateHashedId([t.uid,t.providerId]);let i=await r.getOne(n);if(i)return i;i=new _,Object.assign(i,t);const a=await r.insertOne(n,i);if(!a)throw new Error("Unable to create external user");return a}async findOrCreateOrUpdateDifferenceExternalUser(e,t){const r=await e.resolve(ExternalUserCollection),n=o.CreateHashedId([t.uid,t.providerId]);let i=await r.getOne(n),a=!1;if(i){for(const e of Object.keys(t))if(i[e]!=t[e]&&"object"!=typeof t[e]){a=!0;break}if(!a)return i}const s=i||new _;return Object.assign(s,t),a?r.mergeOne(n,s).then(e=>{if(!e)throw new Error("Unable to merge external user");return s}):r.insertOne(n,s).then(e=>{if(!e)throw new Error("Unable to create external user");return e})}}class ExternalFetcher{constructor(t){if(t&&t.baseURL&&!e.IsAbsoluteURL(t.baseURL))throw new e.Exception({baseURL:t.baseURL},"Invalid fetch base url");this.defaults=t||{}}makeFetchOptions(t={}){const o=Object.assign({},this.defaults.query,t.query||{}),r=Object.assign({},this.defaults.headers,t.headers||{}),n=Object.assign({},t),i=n.headers=new l.Headers(r);let a;if(n.url&&e.IsAbsoluteURL(n.url))a=new URL(n.url);else{if(!this.defaults.baseURL)throw new e.Exception({url:n.url},"Invalid fetch url");a=new URL(this.defaults.baseURL+n.url)}for(const e of Object.keys(o))a.searchParams.append(e,o[e]);if(n.data){const e=(i.get("content-type")||"").toString().toLowerCase();e.startsWith("application/json")?n.body=JSON.stringify(n.data):e.startsWith("application/x-www-form-urlencoded")?n.body=s.stringify(n.data):n.body=n.data,"string"==typeof n.body&&i.set("content-length",String(n.body.length))}return delete n.url,delete n.query,delete n.data,{url:a.toString(),init:n}}httpRequest(e){const{url:t,init:r}=this.makeFetchOptions(e);return d(t,r).then(async e=>{const t={url:e.url,status:e.status,statusText:e.statusText,headers:e.headers,type:e.headers.get("content-type")||"application/octet-stream",body:new o.StreamReader(e.body)};return t.type.startsWith("application/json")&&(t.data=await t.body.json()),t})}httpPost(e,t,o={}){return o.method="POST",o.url=e,o.data=t,this.httpRequest(o)}httpPut(e,t,o={}){return o.method="PUT",o.url=e,o.data=t,this.httpRequest(o)}httpGet(e,t={}){return t.method="GET",t.url=e,this.httpRequest(t)}httpGetAsText(e,t={}){return this.httpGet(e,t).then(e=>e.body.text())}httpGetAsBuffer(e,t={}){return this.httpGet(e,t).then(e=>e.body.buffer())}httpGetAsJson(e,t={}){return this.httpGet(e,t).then(e=>{if(null==e.data)throw new Error("ResponseIsNotJSON");return e.data})}httpDelete(e,t={}){return t.method="DELETE",t.url=e,this.httpRequest(t)}}class OAuth2Client extends ExternalFetcher{constructor(e){super({headers:{Accept:"application/json","Content-Type":"application/json"}}),this.options=e}authorizeURL(e){const t={client_id:this.options.client_id,response_type:"code"};Array.isArray(e.scope)&&(e.scope=e.scope.join(" "));const o=Object.assign({},t,e);return`${this.options.authorization_endpoint}?${s.stringify(o)}`}getToken(e){Array.isArray(e.scope)&&(e.scope=e.scope.join(" "));const t=Object.assign({},e,{client_id:this.options.client_id,client_secret:this.options.client_secret,grant_type:"authorization_code"});return super.httpPost(this.options.token_endpoint,t,{headers:{"Content-Type":"application/x-www-form-urlencoded"}}).then(e=>{if(!e.data)throw new Error("InvalidOAuthTokenResponseType");return e.data}).catch(e=>(console.log("errror get token",e),console.log("try get token using json payload",t),super.httpPost(this.options.token_endpoint,t)))}get(e){return super.httpGetAsJson(e)}}class OpenIdAuthenticator extends WebFoundationService{update(e){this.idProvider=e.provider,this.oauth=new OAuth2Client({client_id:e.appID,client_secret:e.appSecret,authorization_endpoint:e.authorization_endpoint,token_endpoint:e.token_endpoint}),e.scope?this.scope=e.scope:this.scope="openid"}getAuthorizeURL(e,t){return this.oauth.authorizeURL({redirect_uri:e,scope:this.scope,state:String(t)})}getSuccessURL(e){return"/#"+this.construct(AuthenticationSettings).WEB_SIGNIN_SUCCESS_PATH}getFailureURL(e){return"/#"+this.construct(AuthenticationSettings).WEB_SIGNIN_FAILED_PATH}getToken(e,t){return this.oauth.getToken({redirect_uri:e,code:t,scope:this.scope}).then(e=>{if(e.id_token&&"string"==typeof e.id_token)try{const t=e.id_token.split("."),o=Buffer.from(t[1],"base64");e.id_token=JSON.parse(o.toString())}catch(t){e.id_token={},e.id_token_error=t.message}else e.id_token={},e.id_token_error="id_token is not found";return e})}async refreshToken(e){throw new Error("Not implemented refresh token")}async getUserProfile(e){const t=e.id_token;let o=[],r=null,n=null,i=null,a=!1;if(t.email&&(r=t.email,a=t.email_verified),r){const e=r.split("@");n=e[0],i=e[1]}return r&&a&&o.push({type:"email",value:r}),{uid:t.sub,providerData:null,identities:o,username:n,domain:i,email:r,emailCertified:a,mobile:null,mobileCertified:!1,displayName:t.name,displayImageURL:t.picture,familyName:t.family_name,givenName:t.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:t.locale}}}var y,f,v;class OpenIdController extends WebFoundationController{OnProfile(e,t,o){return Promise.resolve(null)}async getAuthenticator(e){const t=e.construct(OpenIdAuthenticator),o=await this.discover(e);return t.update({provider:o,issuer:o.providerURL,appID:o.appID,appSecret:o.appSecret,token_endpoint:o.providerConfiguration.token_endpoint,authorization_endpoint:o.providerConfiguration.authorization_endpoint,scope:o.scope}),t}async[y=Symbol("start")](t){let o;try{const r=await this.getAuthenticator(t),n=a.resolve(t.publicURL,"callback");n.startsWith("http://")&&t.logger.error("Unsecured oauth callback url: "+n),o=r.getAuthorizeURL(n,Date.now())}catch(r){if(r instanceof SyntaxError)return""+r.message;o=await this.getFailureURL(t,new e.Exception(r,"Unable to start authentication"))}return t.redirect(o)}async[f=Symbol("callback")](t){const o=a.resolve(t.publicURL,"callback");o.startsWith("http://")&&t.logger.error("Unsecured oauth callback url: "+o);const r=Number(t.query.state),i=await this.getAuthenticator(t),s=i.idProvider;if(r>Date.now())t.redirect(i.getFailureURL(new n.BadRequestError("InvalidAuthenticationState")));else{if(t.query.error){const e=new n.BadRequestError(`${t.query.error}: ${t.query.error_description}`);return t.logger.error(e,"Authentication Error"),void t.redirect(i.getFailureURL(e))}try{const r=t.query.code,a=await i.getToken(o,r);let l=await this.OnProfile(t,a,s).catch(()=>null);if(l||(l=await i.getUserProfile(a).catch(()=>null)),!l||!l.uid){let e=new n.BadRequestError("Unable to get unique user identity from provider");return t.logger.error(e),void t.redirect(i.getFailureURL(e))}l&&(Reflect.has(l,"user")&&(l.user&&e.Id.IsValid(l.user)?t.logger.warn(`External user ${l.uid}@${s._id} already set the user field to ${l.user}`):delete l.user),l.displayImageURL||t.logger.warn(`External user ${l.uid}@${s._id} do not have a profile image`),l.provider=s.provider,l.providerProtocol=s.providerProtocol,l.providerURL=s.providerURL,l.providerId=s._id.toString());const d=await this.ExternalUsers.findOrCreateOrUpdateDifferenceExternalUser(t,l);let c;await this.ExternalUsers.updateToken(t,a,d),c=d.user?await this.Users.findOneById(t,d.user):d.email&&d.emailCertified?await this.Users.findUserFromEmail(t,d.email):void 0;const p=await t.resolve(CurrentUser).catch(()=>void 0),u=await this.OnAuthenticated(t,s,a,d,c,p);t.redirect(i.getSuccessURL(u))}catch(e){t.logger.error(e,"Authentication Callback Error"),t.redirect(i.getFailureURL(e))}}}}__decorate([t.singleton(),__metadata("design:type",ExternalUserService)],OpenIdController.prototype,"ExternalUsers",void 0),__decorate([t.singleton(),__metadata("design:type",UserService)],OpenIdController.prototype,"Users",void 0),__decorate([n.method("GET","/start"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],OpenIdController.prototype,y,null),__decorate([n.method("GET","/callback"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],OpenIdController.prototype,f,null),function(e){e.SIGN_UP="sign-up",e.SIGN_UP_FAILED="sign-up-failed",e.SIGN_IN="sign-in",e.SIGN_IN_FAILED="sign-in-failed",e.SIGN_OUT="sign-out",e.SESSION_EXPIRED="session-expired",e.ACCESS_DENIED="access-denied"}(v||(v={}));let I=class EventModel extends i.Model{};I=__decorate([i.model("event")],I);class EventCollection extends i.DocumentCollection{constructor(){super(I)}}class OpenIdConnect extends ExternalFetcher{constructor(){super(...arguments),this.ConfigurationEndpoint="/.well-known/openid-configuration"}discovery(e){e.pathname=c.join(e.pathname,this.ConfigurationEndpoint);const t=e.toString();return super.httpGetAsJson(t)}static[t.ClassInitializer](e,t){return Reflect.construct(this,t)}}let C=class ExternalProviderModel extends i.Model{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):"{}",expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):"{}"}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}};C=__decorate([i.model("external_provider")],C);class ExternalProviderCollection extends i.DocumentCollection{constructor(){super(C)}}class ExternalProviderService extends WebFoundationService{async findOrResolveExternalProvider(e,t){const o=this.createProviderId(t),r=await e.resolve(ExternalProviderCollection),n=await r.getOne(o);if(n){if(n.providerConfiguration)return n;if(n.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL),!n.providerConfiguration)throw new Error("Unable to discover external id provider");return r.mergeOne(o,n).then(e=>n)}if(t.providerConfiguration||(t.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL)),!t.providerConfiguration)throw new Error("Unable to discover external id provider");return r.insertOne(o,t).then(e=>{if(!e)throw new Error("Unable to create external provider");return e})}createProviderId(e){const t=[String(e.provider),String(e.providerProtocol),String(e.providerURL)];return e.appID&&t.push(String(e.appID)),o.CreateHashedId(t)}async discoverProviderConfiguration(t,o){let r;try{r=new URL(o)}catch(t){throw new e.Exception(t,"Invalid external provider: "+o)}return"https:"!==r.protocol&&t.logger.warn("Unsecured external id provider: "+o),t.construct(OpenIdConnect).discovery(r).catch(e=>(t.logger.warn(e,{issuer:r},"Unable to discover the configuration"),null))}}class OpenIdAuthController extends OpenIdController{discover(e){return this.OpenIdProfile.discover(e)}async OnProfile(e,t,o){return this.OpenIdProfile.getUserProfile(e,t,o)}async OnAuthenticated(e,t,o,r,i,a){if(i){const o=await this.Authenticator.Authenticate(e.req,i);return o&&(e.logger.debug({user:i._id,email:r.email,roles:i.roles&&i.roles.join(","),session:o.session},`Logged in with ${t.displayName}`),await this.Events.createSignInEvent(e.req,t,i)),i}if(r.email){if(await this.Users.isEmailBeenUsed(e,r.email))throw new n.AuthenticationError(`Email ${r.email} is already been used`)}const s=await this.Users.findOrCreateUserFromExternalUser(e,r);if(!s)throw new n.AuthenticationError({provider:t.provider,providerProtocol:t.providerProtocol,providerId:t._id},`Failed to register user ${r.uid}`);return await this.ExternalUsers.connectUser(e,r,s)||e.logger.error({external_user:r._id,new_created_user:s._id},"Unable to connect external user to new created user"),this.Authenticator.Authenticate(e.req,s).then(o=>o?(e.logger.debug({user:s._id,email:r.email,roles:s.roles&&s.roles.join(","),session:o.session},`First time logged in with ${t.displayName}`),this.Events.createSignUpEvent(e.req,t,s).then(()=>s)):s)}}__decorate([t.singleton(),__metadata("design:type",class EventService extends WebFoundationService{async createUserEvent(t,o,r,n){const i={provider:o.displayName,providerId:o._id,user:{_id:r._id,displayName:r.displayName,displayImageURL:r.displayImageURL}},a=await t.resolve(EventCollection),s=new I;return s.type=n,s.context=i,a.insertOne(t.construct(e.Id,[],!0),s)}async getLatestEvents(e){return[]}async createSignInEvent(e,t,o){return this.createUserEvent(e,t,o,v.SIGN_IN)}async createSignUpEvent(e,t,o){return this.createUserEvent(e,t,o,v.SIGN_UP)}async SignOut(e,t,o){return this.createUserEvent(e,t,o,v.SIGN_OUT)}})],OpenIdAuthController.prototype,"Events",void 0),__decorate([t.singleton(),__metadata("design:type",exports.AuthenticationService)],OpenIdAuthController.prototype,"Authenticator",void 0),__decorate([t.singleton(),__metadata("design:type",ExternalProviderService)],OpenIdAuthController.prototype,"ExternalProvider",void 0);class WeiboSettings extends e.Settings{}__decorate([e.optional(),__metadata("design:type",Boolean)],WeiboSettings.prototype,"OIDC_WEIBO",void 0),__decorate([e.optional(),__metadata("design:type",String)],WeiboSettings.prototype,"OIDC_WEIBO_ISSUER_URL",void 0),__decorate([e.optional(),__metadata("design:type",String)],WeiboSettings.prototype,"OIDC_WEIBO_CLIENT_ID",void 0),__decorate([e.optional(),__metadata("design:type",String)],WeiboSettings.prototype,"OIDC_WEIBO_CLIENT_SECRET",void 0),__decorate([e.optional(),__metadata("design:type",Array)],WeiboSettings.prototype,"OIDC_WEIBO_SCOPES",void 0);class Weibo extends ExternalFetcher{constructor(e){if(super({baseURL:"https://api.weibo.com",query:{access_token:e}}),!e)throw new Error("Access token can not be null or empty")}get(e,t){return super.httpGetAsJson(e,t)}post(e,t,o){return super.httpPost(e,t,o)}comments(e={}){return this.get("/2/comments/to_me.json",e)}mentions(e={}){return this.get("/2/comments/mentions.json",e)}reposts(e={}){return this.get("/2/statuses/mentions.json",e)}weibo(e={}){return this.get("/2/statuses/home_timeline.json",e)}getLimits(){return this.get("/2/account/rate_limit_status.json",{})}}class WeiboOpenIdService{async discover(t){const o=t.construct(WeiboSettings);if(!o.OIDC_WEIBO)throw new Error("WeiboAuthIsNotEnabled");const r={provider:"weibo",providerProtocol:"oauth",providerURL:o.OIDC_WEIBO_ISSUER_URL,displayName:"Weibo Account",displayImageURL:"https://www.weibo.com/favicon.ico",providerConfiguration:{issuer:o.OIDC_WEIBO_ISSUER_URL,authorization_endpoint:"https://api.weibo.com/oauth2/authorize",token_endpoint:"https://api.weibo.com/oauth2/access_token",userinfo_endpoint:"https://api.weibo.com/2/users/show.json"}},n=await this.OpenIdProvider.findOrResolveExternalProvider(t,r),i=n.appID||o.OIDC_WEIBO_CLIENT_ID;if(!i)throw new e.MissingConfigurationValueError("OIDC_WEIBO_CLIENT_ID");const a=n.appSecret||o.OIDC_WEIBO_CLIENT_SECRET;if(!a)throw new e.MissingConfigurationValueError("OIDC_WEIBO_CLIENT_SECRET");return n.appID=i,n.appSecret=a,o.OIDC_WEIBO_SCOPES&&(n.scope=o.OIDC_WEIBO_SCOPES.join(" ")),n}async getUserProfile(e,t,o){if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const r=new Weibo(t.access_token),n=await r.post("https://api.weibo.com/oauth2/get_token_info",null);t.appkey=n.appkey;const i=await r.get(o.providerConfiguration.userinfo_endpoint,{query:{uid:t.uid}}).catch(e=>{throw console.log("unable to get weibot profile",e),e});return{uid:i.id,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:i,userData:{},identities:[],username:i.domain||null,domain:null,domainCertified:!1,email:null,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:i.screen_name,displayImageURL:i.profile_image_url,familyName:null,givenName:null,gender:i.gender,dob:null,status:i.status?i.status.text:null,bio:i.description,homepage:i.url||null,locale:i.lang}}}__decorate([t.singleton(),__metadata("design:type",ExternalProviderService)],WeiboOpenIdService.prototype,"OpenIdProvider",void 0),exports.WeiboOpenIdAuthController=class WeiboOpenIdAuthController extends OpenIdAuthController{},__decorate([t.singleton(),__metadata("design:type",WeiboOpenIdService)],exports.WeiboOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.WeiboOpenIdAuthController=__decorate([n.controller("/api/integration/weibo/auth")],exports.WeiboOpenIdAuthController);class BearerClient extends ExternalFetcher{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error("Access token can not be null or empty")}get(e,t){return super.httpGetAsJson(e)}post(e,t,o){return super.httpPost(e,t,o)}}class BitBucketSettings extends e.Settings{}__decorate([e.optional(),__metadata("design:type",Boolean)],BitBucketSettings.prototype,"OIDC_BITBUCKET",void 0),__decorate([e.optional(),__metadata("design:type",String)],BitBucketSettings.prototype,"OIDC_BITBUCKET_ISSUER_URL",void 0),__decorate([e.optional(),__metadata("design:type",String)],BitBucketSettings.prototype,"OIDC_BITBUCKET_CLIENT_ID",void 0),__decorate([e.optional(),__metadata("design:type",String)],BitBucketSettings.prototype,"OIDC_BITBUCKET_CLIENT_SECRET",void 0),__decorate([e.optional(),__metadata("design:type",Array)],BitBucketSettings.prototype,"OIDC_BITBUCKET_SCOPES",void 0);class BitBucketProfileService{async discover(t){const o=t.construct(BitBucketSettings);if(!o.OIDC_BITBUCKET)throw new Error("BitBucketAuthIsNotEnabled");const r={provider:"bitbucket",providerProtocol:"openid",providerURL:o.OIDC_BITBUCKET_ISSUER_URL,displayName:"BitBucket Account",displayImageURL:"https://bitbucket.org/favicon.ico",providerConfiguration:{issuer:o.OIDC_BITBUCKET_ISSUER_URL,authorization_endpoint:"https://bitbucket.org/site/oauth2/authorize",token_endpoint:"https://bitbucket.org/site/oauth2/access_token",userinfo_endpoint:"https://api.bitbucket.org/2.0/user"}},n=await this.OpenIdProvider.findOrResolveExternalProvider(t,r),i=n.appID||o.OIDC_BITBUCKET_CLIENT_ID;if(!i)throw new e.MissingConfigurationValueError("OIDC_BITBUCKET_CLIENT_ID");const a=n.appSecret||o.OIDC_BITBUCKET_CLIENT_SECRET;if(!a)throw new e.MissingConfigurationValueError("OIDC_BITBUCKET_CLIENT_SECRET");return n.appID=i,n.appSecret=a,o.OIDC_BITBUCKET_SCOPES&&(n.scope=n.scope||o.OIDC_BITBUCKET_SCOPES.join(" ")),n}async getUserProfile(e,t,o){const r=new BearerClient(t.access_token),n=await r.get(o.providerConfiguration.userinfo_endpoint),i=await r.get("https://api.bitbucket.org/2.0/user/emails");let a="",s=!1;const l=[];if(i&&i.values)for(const e of i.values)"email"===e.type&&e.is_primary&&(a=e.email,s=e.is_confirmed);return a&&s&&l.push({type:"email",value:a}),{uid:n.account_id,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:n,userData:{},identities:l,username:n.nickname,domain:"",domainCertified:!1,email:a,emailCertified:s,mobile:"",mobileCertified:!1,displayName:n.display_name,displayImageURL:"",familyName:"",givenName:"",gender:null,dob:null,status:null,bio:"",homepage:n.website,locale:""}}}__decorate([t.singleton(),__metadata("design:type",ExternalProviderService)],BitBucketProfileService.prototype,"OpenIdProvider",void 0),exports.BitBucketOpenIdAuthController=class BitBucketOpenIdAuthController extends OpenIdAuthController{},__decorate([t.singleton(),__metadata("design:type",BitBucketProfileService)],exports.BitBucketOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.BitBucketOpenIdAuthController=__decorate([n.controller("/api/integration/bitbucket/auth")],exports.BitBucketOpenIdAuthController);class GoogleSettings extends e.Settings{}__decorate([e.optional(),__metadata("design:type",Boolean)],GoogleSettings.prototype,"OIDC_GOOGLE",void 0),__decorate([e.optional(),__metadata("design:type",String)],GoogleSettings.prototype,"OIDC_GOOGLE_ISSUER_URL",void 0),__decorate([e.optional(),__metadata("design:type",String)],GoogleSettings.prototype,"OIDC_GOOGLE_CLIENT_ID",void 0),__decorate([e.optional(),__metadata("design:type",String)],GoogleSettings.prototype,"OIDC_GOOGLE_CLIENT_SECRET",void 0),__decorate([e.optional(),__metadata("design:type",Array)],GoogleSettings.prototype,"OIDC_GOOGLE_SCOPES",void 0);class GoogleProfileService{constructor(){this.TrustedEmailDomains=["gmail.com"]}async discover(t){const o=t.construct(GoogleSettings);if(!o.OIDC_GOOGLE)throw new Error("GoogleAuthIsNotEnabled");const r={provider:"google",providerProtocol:"openid",providerURL:o.OIDC_GOOGLE_ISSUER_URL,displayName:"Google Account",displayImageURL:"https://www.google.com/favicon.ico"},n=await this.OpenIdProvider.findOrResolveExternalProvider(t,r),i=n.appID||o.OIDC_GOOGLE_CLIENT_ID;if(!i)throw new e.MissingConfigurationValueError("OIDC_GOOGLE_CLIENT_ID");const a=n.appSecret||o.OIDC_GOOGLE_CLIENT_SECRET;if(!a)throw new e.MissingConfigurationValueError("OIDC_GOOGLE_CLIENT_SECRET");return n.appID=i,n.appSecret=a,o.OIDC_GOOGLE_SCOPES&&(n.scope=n.scope||o.OIDC_GOOGLE_SCOPES.join(" ")),n}async getUserProfile(e,t,o){const r=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const n=new BearerClient(t.access_token),i=await n.get(o.providerConfiguration.userinfo_endpoint).catch(()=>null);let a=[],s=null,l=null,d=null,c=!1;if(r.picture?d=r.picture:i&&i.picture&&(d=i.picture),r.email&&(s=r.email),s){const e=s.split("@");l=e[0],this.TrustedEmailDomains.indexOf(e[1].toLowerCase())>=0&&(c=r.email_verified)}return s&&c&&a.push({type:"email",value:s}),{uid:r.sub,provider:o.provider,providerProtocol:o.providerProtocol,providerId:o._id,providerData:i,userData:{},identities:a,username:l,domain:null,domainCertified:!1,email:s,emailCertified:c,mobile:null,mobileCertified:!1,displayName:r.name,displayImageURL:d,familyName:r.family_name,givenName:r.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:r.locale}}}__decorate([t.singleton(),__metadata("design:type",ExternalProviderService)],GoogleProfileService.prototype,"OpenIdProvider",void 0),exports.GoogleOpenIdAuthController=class GoogleOpenIdAuthController extends OpenIdAuthController{},__decorate([t.singleton(),__metadata("design:type",GoogleProfileService)],exports.GoogleOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.GoogleOpenIdAuthController=__decorate([n.controller("/api/integration/google/auth")],exports.GoogleOpenIdAuthController);class GitLabSettings extends e.Settings{}__decorate([e.optional(),__metadata("design:type",Boolean)],GitLabSettings.prototype,"OIDC_GITLAB",void 0),__decorate([e.optional(),__metadata("design:type",String)],GitLabSettings.prototype,"OIDC_GITLAB_ISSUER_URL",void 0),__decorate([e.optional(),__metadata("design:type",String)],GitLabSettings.prototype,"OIDC_GITLAB_CLIENT_ID",void 0),__decorate([e.optional(),__metadata("design:type",String)],GitLabSettings.prototype,"OIDC_GITLAB_CLIENT_SECRET",void 0),__decorate([e.optional(),__metadata("design:type",Array)],GitLabSettings.prototype,"OIDC_GITLAB_SCOPES",void 0);class GitLabProfileService{async discover(t){const o=t.construct(GitLabSettings);if(!o.OIDC_GITLAB)throw new Error("GitLabAuthIsNotEnabled");const r={provider:"gitlab",providerProtocol:"openid",providerURL:o.OIDC_GITLAB_ISSUER_URL,displayName:"GitLab Account",displayImageURL:"https://about.gitlab.com/ico/favicon-192x192.png"},n=await this.OpenIdProvider.findOrResolveExternalProvider(t,r),i=n.appID||o.OIDC_GITLAB_CLIENT_ID;if(!i)throw new e.MissingConfigurationValueError("OIDC_GITLAB_CLIENT_ID");const a=n.appSecret||o.OIDC_GITLAB_CLIENT_SECRET;if(!a)throw new e.MissingConfigurationValueError("OIDC_GITLAB_CLIENT_SECRET");return n.appID=i,n.appSecret=a,o.OIDC_GITLAB_SCOPES&&(n.scope=n.scope||o.OIDC_GITLAB_SCOPES.join(" ")),n}async getUserProfile(e,t,o){const r=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const n=new BearerClient(t.access_token),i=await n.get(o.providerConfiguration.userinfo_endpoint);let a=[],s=i.picture;return i.email&&i.email_verified&&a.push({type:"email",value:i.email}),{uid:r.sub,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:i,userData:{},identities:a,username:i.nickname||null,domain:null,domainCertified:!1,email:i.email||null,emailCertified:i.email_verified||!1,mobile:null,mobileCertified:!1,displayName:r.name||i.name,displayImageURL:s,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:null,homepage:i.profile||null,locale:null}}}__decorate([t.singleton(),__metadata("design:type",ExternalProviderService)],GitLabProfileService.prototype,"OpenIdProvider",void 0),exports.GitLabOpenIdAuthController=class GitLabOpenIdAuthController extends OpenIdAuthController{},__decorate([t.singleton(),__metadata("design:type",GitLabProfileService)],exports.GitLabOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.GitLabOpenIdAuthController=__decorate([n.controller("/api/integration/gitlab/auth")],exports.GitLabOpenIdAuthController);class GitHubSettings extends e.Settings{}__decorate([e.optional(),__metadata("design:type",Boolean)],GitHubSettings.prototype,"OIDC_GITHUB",void 0),__decorate([e.optional(),__metadata("design:type",String)],GitHubSettings.prototype,"OIDC_GITHUB_ISSUER_URL",void 0),__decorate([e.optional(),__metadata("design:type",String)],GitHubSettings.prototype,"OIDC_GITHUB_CLIENT_ID",void 0),__decorate([e.optional(),__metadata("design:type",String)],GitHubSettings.prototype,"OIDC_GITHUB_CLIENT_SECRET",void 0),__decorate([e.optional(),__metadata("design:type",Array)],GitHubSettings.prototype,"OIDC_GITHUB_SCOPES",void 0);class GitHubProfileService{async discover(t){const o=t.construct(GitHubSettings);if(!o.OIDC_GITHUB)throw new Error("GitHubAuthIsNotEnabled");const r={provider:"github",providerProtocol:"oauth",providerURL:o.OIDC_GITHUB_ISSUER_URL,displayName:"GitHub Account",displayImageURL:"https://github.com/favicon.ico",providerConfiguration:{issuer:o.OIDC_GITHUB_ISSUER_URL,authorization_endpoint:"https://github.com/login/oauth/authorize",token_endpoint:"https://github.com/login/oauth/access_token",userinfo_endpoint:"https://api.github.com/user"}},n=await this.OpenIdProvider.findOrResolveExternalProvider(t,r),i=n.appID||o.OIDC_GITHUB_CLIENT_ID;if(!i)throw new e.MissingConfigurationValueError("OIDC_GITHUB_CLIENT_ID");const a=n.appSecret||o.OIDC_GITHUB_CLIENT_SECRET;if(!a)throw new e.MissingConfigurationValueError("OIDC_GITHUB_CLIENT_SECRET");return n.appID=i,n.appSecret=a,o.OIDC_GITHUB_SCOPES&&(n.scope=n.scope||o.OIDC_GITHUB_SCOPES.join(" ")),n}async getUserProfile(e,t,o){const r=new BearerClient(t.access_token),n=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const i=await r.get(o.providerConfiguration.userinfo_endpoint),a=await r.get("https://api.github.com/user/emails").then(e=>[]);let s=i.id,l=null,d=i.avatar_url,c=[];if(a&&a.length)for(const e of a)e.email&&e.primary&&e.verified&&(l=e.email,c.push({type:"email",value:e.email}));return{uid:s,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:i,userData:{},identities:c,username:i.login,domain:null,domainCertified:!1,email:l,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:i.name||i.login,displayImageURL:d,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:i.bio||null,homepage:i.blog||i.html_url||null,locale:n.locale}}}__decorate([t.singleton(),__metadata("design:type",ExternalProviderService)],GitHubProfileService.prototype,"OpenIdProvider",void 0),exports.GitHubOpenIdAuthController=class GitHubOpenIdAuthController extends OpenIdAuthController{},__decorate([t.singleton(),__metadata("design:type",GitHubProfileService)],exports.GitHubOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.GitHubOpenIdAuthController=__decorate([n.controller("/api/integration/github/auth")],exports.GitHubOpenIdAuthController);class MicrosoftGraphClient extends ExternalFetcher{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error("Access token can not be null or empty")}profile(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/me")}photo(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/me/photo").catch(t=>{const o=t.response.status;if(404===o||501===o)return null;throw new e.Exception(t,t.response.data,"Unable to resolve user photo")})}photoImage(e){return e?this.httpGetAsBuffer(`https://graph.microsoft.com/v1.0/me/photos/${e}/$value`):this.httpGetAsBuffer("https://graph.microsoft.com/v1.0/me/photo/$value")}photoImageDataURL(){return this.photo().then(e=>{if(!e)return Promise.resolve(null);const t=e["@odata.mediaContentType"],o=e.id;return this.photoImage(o).then(e=>`data:${t};charset=utf-8;base64,${e.toString("base64")}`)})}users(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/users")}getNextUsers(e){return this.httpGetAsJson(e)}}let S=class FileModel extends i.Model{};S=__decorate([i.model("file")],S);class FileCollection extends i.BlobCollection{constructor(){super(S)}}let E=class FileTokenModel extends i.Model{};E=__decorate([i.model("file_token")],E);class FileTokenCollection extends i.DocumentCollection{constructor(){super(E)}}class WebFileService{async findTokenById(e,t){return(await e.resolve(FileTokenCollection)).getOne(t)}async findFileById(e,t){return(await e.resolve(FileCollection)).get(t)}async updateOne(e,t,o){return(await e.resolve(FileTokenCollection)).mergeOne(t,{title:o.title})}hash(t){const o=p.createHash("sha256").update(t).digest(),r=Buffer.concat([Buffer.from([18,32]),o]);return e.Base58.fromBytes(r)}async insertFromURL(e,t,o){const r=t.split("/"),n=r[r.length-1],i=await function fetchRemoteURL(e){return d(e).then(async e=>({data:await e.buffer(),dataType:e.headers.get("content-type")||"application/octet-stream",dataLength:parseInt(e.headers.get("content-length")||"0")}))}(t),a=this.hash(i.data);return this.insertFromBuffer(e,a,i.data,Object.assign({},o,{originalname:n,originalurl:t,type:i.dataType}))}async insertFromBuffer(e,t,o,r){let{type:n,width:i,height:a,duration:s,ipfs:l}=r;const d=await e.resolve(FileCollection),c=await d.get(t);if(c)n=c.type,i=c.width,a=c.height,s=c.duration,l=c.ipfs;else{const e={type:n,byteLength:o.byteLength,data:o};if(r&&(e.width=r.width,e.height=r.height,e.duration=r.duration,e.ipfs=r.ipfs),!await d.add(t,e))throw new Error("UnableToSaveDataChunk")}return Object.assign({id:t,type:n||"application/octet-stream",byteLength:o.byteLength,width:i,height:a,duration:s,ipfs:l})}}class MicrosoftSettings extends e.Settings{}__decorate([e.optional(),__metadata("design:type",Boolean)],MicrosoftSettings.prototype,"OIDC_MICROSOFT",void 0),__decorate([e.optional(),__metadata("design:type",String)],MicrosoftSettings.prototype,"OIDC_MICROSOFT_ISSUER_URL",void 0),__decorate([e.optional(),__metadata("design:type",String)],MicrosoftSettings.prototype,"OIDC_MICROSOFT_CLIENT_ID",void 0),__decorate([e.optional(),__metadata("design:type",String)],MicrosoftSettings.prototype,"OIDC_MICROSOFT_CLIENT_SECRET",void 0),__decorate([e.optional(),__metadata("design:type",Array)],MicrosoftSettings.prototype,"OIDC_MICROSOFT_SCOPES",void 0);class MicrosoftOpenIdService{constructor(){this.TrustedMicrosoftEmailDomains=["outlook.com","hotmail.com","live.cn","live.com","msn.com","passport.com","passport.net"]}async discover(t){const o=t.construct(MicrosoftSettings);if(!o.OIDC_MICROSOFT)throw new Error("MicrosoftAuthIsNotEnabled");const r={provider:"microsoft",providerProtocol:"openid",providerURL:o.OIDC_MICROSOFT_ISSUER_URL,displayName:"Microsoft Account",displayImageURL:"https://www.microsoft.com/favicon.ico"},n=await this.OpenIdProvider.findOrResolveExternalProvider(t,r),i=n.appID||o.OIDC_MICROSOFT_CLIENT_ID;if(!i)throw new e.MissingConfigurationValueError("OIDC_MICROSOFT_CLIENT_ID");const a=n.appSecret||o.OIDC_MICROSOFT_CLIENT_SECRET;if(!a)throw new e.MissingConfigurationValueError("OIDC_MICROSOFT_CLIENT_SECRET");return n.appID=i,n.appSecret=a,o.OIDC_MICROSOFT_SCOPES&&(n.scope=n.scope||o.OIDC_MICROSOFT_SCOPES.join(" ")),n}async getUserProfile(e,t,o){const r=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return console.log("provider not"),null;console.log("----------------------"),console.log("|      id_token      |"),console.log("======================"),console.log(r),console.log("======================");const n=new MicrosoftGraphClient(t.access_token),i=await n.profile().catch(()=>null);console.log("----------------------"),console.log("|      profile       |"),console.log("======================"),console.log(i),console.log("======================");const a=await n.photo();if(a){const t=await n.photoImage(a.id);if(t){const o=await e.resolve(WebFileService),r=o.hash(t),n=await o.insertFromBuffer(e,r,t,{type:a["@odata.mediaContentType"],width:a.width,height:a.height}).catch(e=>(console.log("err",e),console.log(`Unable to save profile image for microsoft user ${a.id}, displayImageURL will be NULL`),null));console.log("profile image",n)}}console.log("----------------------"),console.log("|      photo       |"),console.log("======================"),console.log(null),console.log("======================");let s=null,l=null,d=null,c=null,p=[],u=null,g=!1;if(i?(s=i.id,l=i.displayName):(s=r.oid||r.sub,l=r.name),r.preferred_username?d=r.preferred_username:i&&i.userPrincipalName&&(d=i.userPrincipalName),d){const e=d.split("@");2===e.length&&(c=e[1].toLowerCase())}if(r.email?u=r.email:i&&i.mail&&(u=i.mail),u){const t=u.split("@");if(2===t.length){this.TrustedMicrosoftEmailDomains.indexOf(t[1].toLowerCase())>=0&&(g=!0);const r=e.construct(WebFoundationSettings);for(const e of r.TRUSTED_EMAIL_PROVIDERS||[])if(("microsoft"===e.provider||e.provider===o.providerURL)&&e.domains.indexOf(t[1].toLowerCase())>=0){g=!0;break}}}return u&&g&&p.push({type:"email",value:u}),{uid:s,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:i,userData:{},identities:p,username:d,domain:c,domainCertified:!1,email:u,emailCertified:g,mobile:i&&i.mobilePhone,mobileCertified:!1,displayName:l,displayImageURL:null,familyName:i&&i.surname,givenName:i&&i.givenName,gender:null,dob:null,status:null,bio:i&&i.jobTitle,homepage:null,locale:i&&i.preferredLanguage}}}__decorate([t.singleton(),__metadata("design:type",ExternalProviderService)],MicrosoftOpenIdService.prototype,"OpenIdProvider",void 0),exports.MicrosoftOpenIdAuthController=class MicrosoftOpenIdAuthController extends OpenIdAuthController{},__decorate([t.singleton(),__metadata("design:type",MicrosoftOpenIdService)],exports.MicrosoftOpenIdAuthController.prototype,"OpenIdProfile",void 0),exports.MicrosoftOpenIdAuthController=__decorate([n.controller("/api/integration/microsoft/auth")],exports.MicrosoftOpenIdAuthController),exports.DialogAttribute=class DialogAttribute{constructor(e){this._name=e}beforeDecorate(e,t,o){return!0}get name(){return this._name}},exports.DialogAttribute=__decorate([t.attribute(),__metadata("design:paramtypes",[String])],exports.DialogAttribute);class BotService extends e.Resolvable{}const w=[];class BotStateService extends BotService{BotStateService(){this.history=w,console.log("loading bot state from memory......")}async save(){console.log("saving bot state to memory......")}empty(){return!this.history.length}start(e){this.history.push([e,0,!0])}end(){for(let e=this.history.length-1;e>=0;e--){if(this.history[e][2])return void this.history.splice(e,this.history.length-e)}}isEnd(){const e=this.last();return!e||!!e[2]}push(e,t){this.history.push([e,0,t])}pop(){return this.history.pop()}last(){return this.history[this.history.length-1]}next(){const e=this.last();return e&&(e[1]=e[1]+1),e}restart(){const e=this.last();e&&(e[1]=0)}clear(){this.history.splice(0,this.history.length)}}class BotStateModel{}exports.BotStateCollection=class BotStateCollection extends i.RecordCollection{constructor(){super(BotStateModel)}},exports.BotStateCollection=__decorate([i.collection("state"),__metadata("design:paramtypes",[])],exports.BotStateCollection);class DialogAction{}class DialogRouteAction extends DialogAction{constructor(e){super(),this.data=e}}class DialogResponseAction extends DialogAction{}class StartDialog extends DialogRouteAction{constructor(e,t){super(t),this.path=e}}class ReplaceDialog extends DialogRouteAction{constructor(e,t){super(t),this.path=e}}class RestartDialog extends DialogRouteAction{constructor(e){super(e)}}class EndDialog extends DialogRouteAction{constructor(e){super(e)}}class EndConversation extends DialogRouteAction{constructor(e){super(e)}}class ResetBot extends DialogRouteAction{constructor(e){super(e)}}class TextResponse extends DialogResponseAction{constructor(e,t){super(),this.text=e,this.format=t}}class DataResponse extends DialogResponseAction{constructor(e){super(),this.data=e}}class BotContext extends e.Container{sendText(t,o){throw new e.NotSupportedException("sendText")}replyText(t,o){throw new e.NotSupportedException("replyText")}startDialog(e,t){return new StartDialog(e,t)}replaceDialog(e,t){return new ReplaceDialog(e,t)}restartDialog(e){return new ReplaceDialog(this.path,e)}endDialog(e){return new EndDialog(e)}endConversation(e){return new EndConversation(e)}resetBot(e){return new ResetBot(e)}}const x=new WeakMap;function GetBotContextData(e){return x.get(e)}function SetBotContextData(e,t){x.set(e,t)}var O;let b=O=class BotRouter extends e.Resolvable{search(e){throw new t.TypeNotFoundError(O)}add(e){throw new t.TypeNotFoundError(O)}};b=O=__decorate([t.extensible()],b);class TypeRouterBindings extends e.Chain{}class BotDialogRouter extends b{search(e){return this._tree.search(e)}add(e,t){const o=u.Reflector(e),r=o.getOwnAttributes(n.ControllerAttribute),i=new Set;if(!r.length)throw new TypeError(`No @controller() attribute found on type ${e.prototype.constructor.name}`);for(const a of r){const r=a.path,s=this.createMiddleware(e),l=s.methods;for(const e of o.findTypes(e=>e.hasOwnProperties()).reverse())for(const o of e.getOwnProperties()){const e=o.key,d=e.toString();if(i.has(e))throw new TypeError(`Unable to override route for ${d}`);const c=l.length;let p=!1;const u=o.getOwnAttributes(n.MiddlewareAttribute);for(const e of u)t&&t.beforeMiddleware&&!t.beforeMiddleware(a,e,o)||(this.addMiddleware(s,o,c),p=!0);for(const e of o.getOwnAttributes(exports.DialogAttribute)){if(t&&t.beforeDialog&&!t.beforeDialog(a,e,o))continue;const n=e.name?r+e.name:r||"",i=this._tree.data(n);this.addDialog(s,o,i,c),p=!0}p&&(i.add(e),l.push(e))}}return this}createMiddleware(e){const t=new TypeRouterBindings;return t.performance=o.Performance,t.dataOf=GetBotContextData,t.type=e,t.methods=[],t.push(this.generateInitializerFn(t)),t}addMiddleware(e,t,o){e.push(this.generateMiddlewareFn(e,t,o))}addDialog(e,t,o,r){o.steps=o.steps||[],o.steps.push(this.generateDialogFn(e,t,r))}makeInvokeMethod(e,t){return"string"==typeof e?`.${e}`:"number"==typeof e?`[${e}]`:`[this.methods[${t}]]`}generateInitializerFn(e){return Function("ctx","next","if (!this.instance) {\n  this.performance.log(ctx, 'dialog', '[[new ' + this.type.prototype.constructor.name + '()]]');\n  this.instance = ctx.construct(this.type, true);\n}\nreturn next();").bind(e)}generateMiddlewareFn(e,t,o){const r=t.name,n=this.makeInvokeMethod(t.key,o);let i;return i=t.descriptor&&t.descriptor.value.length>2?`return this.performance.log(btx,'dialog','[${r}]'),this.instance${n}(btx, this.dataOf(btx), next);`:`return this.performance.log(btx,'dialog','[${r}]'),this.instance${n}(btx, next);`,Function("btx","next",i).bind(e)}generateDialogFn(e,t,o){const r=t.name,n=this.makeInvokeMethod(t.key,o);let i;i=t.descriptor&&t.descriptor.value.length>1?`return this.performance.log(btx,'dialog','${r}()'),this.instance${n}(btx, this.dataOf(btx));`:`return this.performance.log(btx,'dialog','${r}()'),this.instance${n}(btx);`;let a="";return a=e.length?"return btx.params=params,this.compose(this,btx,()=>{\n"+`  ${i}\n`+"});":i,Function("btx","params",a).bind(e)}}__decorate([t.transit(),__metadata("design:type",e.PrefixTree)],BotDialogRouter.prototype,"_tree",void 0);class DialogError extends e.Exception{}async function BotRoutingMiddleware(e,t){let r=e.path,i=e.pathIndex;o.Performance.log(e,"dialog"),e.logger.info(`[${e.identity.address}] --\x3e BOT ${r}[${i}]: ${e.message.text||"<redirect>"}`);const a=e.construct(BotDialogRouter).search(r);if(!(a&&a.data&&a.data.steps&&a.data.steps.length)){if(r.startsWith("/event/"))return console.log(`WARN: ${r} not found, end dialog and pop`),new EndDialog(GetBotContextData(e));throw new n.NotFoundError({path:r},"DialogNotFound")}const s=a.data.steps,l=s[i];if(!l)return console.log("WARN: path index not found, end dialog and pop"),new EndDialog(GetBotContextData(e));const d=!!s[i+1];return l(e,a.params).then(e=>d?e instanceof DialogResponseAction?e:e instanceof DialogRouteAction?e:"string"==typeof e?new TextResponse(e):new DataResponse(e):e instanceof DialogRouteAction?e:new EndDialog(e),e=>Promise.reject(new DialogError(e,e.message)))}async function BotStateMiddleware(e,t){let r,n;o.Performance.log(e,"state");const i=await e.resolve(BotStateService);if(e.path)r=e.path,n=e.pathIndex,i.push(r);else{const e=i.last();e?(r=e[0],n=e[1]):(r="/",n=0)}return e.path=r||"/",e.pathIndex=n||0,t().then(e=>{if(e instanceof DialogRouteAction)if(e instanceof EndDialog){const t=i.isEnd();if(i.pop(),t)return new TextResponse(e.data)}else if(e instanceof StartDialog)i.next(),i.push(c.resolve(r,e.path));else if(e instanceof ReplaceDialog)i.pop(),i.push(c.resolve(r,e.path));else{if(!(e instanceof RestartDialog))return e instanceof ResetBot?(i.clear(),new TextResponse("ResetBot")):(i.pop(),i.end(),new TextResponse("EndConversation"));i.restart()}else i.next();return e})}class TelegramClient extends ExternalFetcher{constructor(e){if("string"!=typeof e&&!e)throw new Error("apiKey can not be null or empty");super({baseURL:`https://api.telegram.org/bot${e}`,headers:{"Content-Type":"application/json"}})}static[t.ClassInitializer](e,t){return Reflect.construct(this,t)}getMe(){return this.post("/getMe")}getUserProfilePhotos(e){const t={user_id:String(e)};return this.post(`/getUserProfilePhotos?${s.stringify(t)}`)}getFile(e){const t={file_id:e};return this.post(`/getFile?${s.stringify(t)}`)}sendMessage(e,t,o){return this.post("/sendMessage",{chat_id:e,text:t,parse_mode:"html",disable_web_page_preview:!0,...o})}editMessageText(e,t,o,r){return this.post("/editMessageText",{chat_id:e,message_id:t,text:o,parse_mode:"html",...r})}editMessageReplyMarkup(e,t,o){return this.post("/editMessageReplyMarkup",{chat_id:e,message_id:t,...o})}forwardMessage(e,t,o){return this.post("/forwardMessage",{chat_id:e,from_chat_id:t,message_id:o})}answerCallbackQuery(e,t,o,r){return this.post("/answerCallbackQuery",{callback_query_id:e,text:t,show_alert:o,url:r})}setWebhook(e,t,o,r){return this.post("/setWebhook",{url:e,certificate:t,max_connections:o,allowed_updates:r})}getWebhookInfo(){return this.post("/getWebhookInfo")}sendDocument(e,t,o){const r=new(require("form-data"));return r.append("chat_id",String(e)),o&&r.append("caption",o),r.append("document",t.data,{filename:t.filename,contentType:t.type}),this.post("/sendDocument",r,{headers:r.getHeaders()})}sendChatAction(e,t){return this.post("/sendChatAction",{chat_id:e,action:t})}sendInvoice(e,t,o,r,n={}){const i={chat_id:e,provider_token:t,start_parameter:r,need_name:!0,need_phone_number:!0,need_email:!0,...o,...n};return this.post("/sendInvoice",i)}answerPreCheckoutQuery(e,t){const o={pre_checkout_query_id:e,ok:!0};return t&&(o.ok=!1,o.message=t),this.post("/answerPreCheckoutQuery",o)}getChat(e){const t={chat_id:e};return this.post("/getChat",t)}exportChatInviteLink(e){const t={chat_id:e};return this.post("/exportChatInviteLink",t)}post(t,o,r){return e.retry(()=>this.httpPost(t,o,r)).then(e=>e.data?{ok:e.data.ok?1:0,result:e.data.result}:{ok:0,errcode:400,message:"not a json response"},e=>({ok:0,errcode:e.errno,message:e.message}))}}class TelegramBotSettings extends e.Settings{}__decorate([e.optional(),__metadata("design:type",Number)],TelegramBotSettings.prototype,"TELEGRAM_BOT_ID",void 0),__decorate([e.optional(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_NAME",void 0),__decorate([e.optional(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_DISPLAY_NAME",void 0),__decorate([e.optional(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_TOKEN",void 0),__decorate([e.optional(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_PAYMENT_PROVIDER_TOKEN",void 0),__decorate([e.optional(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_SECRET_KEY",void 0),__decorate([e.optional(),__metadata("design:type",Number)],TelegramBotSettings.prototype,"TELEGRAM_BOT_DIALOG_TIMEOUT_IN_SECONDS",void 0);class Telegram extends BotService{get client(){const e=this.construct(TelegramBotSettings);return new TelegramClient(e.TELEGRAM_BOT_SECRET_KEY)}setupWebhook(t){return this.client.getWebhookInfo().then(e=>e.ok&&e.result.url.startsWith(t)?(this.logger.info({url:e.result.url},"Telegram webhook is up to date"),e):(this.logger.info({url:t},"Updating Telegram Webhook url"),this.client.setWebhook(t).then(e=>(this.logger.info({result:e},`Telegram webhook updated to: ${t}`),e)))).catch(t=>{throw this.logger.error(t),new e.Exception(t,"Unable to update Telegram webhook url")})}getMe(){return this.client.getMe()}sendText(e,t,o){return this.client.sendMessage(e,t,o)}sendInvoice(e,t,o,r){return this.client.sendInvoice(e,t,o,r)}sendCode(e,t,o){return this.client.sendMessage(e,`<code>${t}</code>`,{parse_mode:"html",...o})}confirmInvoice(e,t){return this.client.answerPreCheckoutQuery(e,t)}getChat(e){return this.client.getChat(e)}exportChatInviteLink(e){return this.client.exportChatInviteLink(e)}}async function BotErrorMiddleware(e,t){return t().catch(t=>{const o=e.construct(Telegram);return e.logger.error(t,{bot:e.bot.username,path:`${e.path}[${String(e.pathIndex)}]`,identity:e.identity},"BotError"),o.sendCode(e.event.chat.id,`${t.name}: ${t.message}`,{reply_to_message_id:e.message.id}).then(()=>void 0,()=>void 0)})}__decorate([t.once(),__metadata("design:type",Object),__metadata("design:paramtypes",[])],Telegram.prototype,"client",null);const T=new WeakSet;async function BotEventMiddleware(e,t){if(!T.has(e)&&(T.add(e),!e.path)){const t=await e.resolve(BotStateService);if(console.log("msg",e.message),e.message.command){e.logger.info(`[${e.identity.address}] --\x3e CMD ${e.message.text}`);const{command:o,commandArgs:r}=e.message;t.start(o),SetBotContextData(e,r)}else"event/callback"===e.event.type?e.path="/"+e.event.type:"event/checkout"===e.event.type?e.path="/"+e.event.type:"event/payment"===e.event.type?e.path="/"+e.event.type:t.empty()&&t.start("/")}return t()}async function BotLoggingMiddleware(e,t){let o=e.identity.profile?e.identity.profile.displayName:"Guest";return e.logger.info(`[${e.identity.address}] --\x3e ${o}: ${e.message.text||`[${e.event.type}]`}`),t()}const B=new WeakMap;class Bot extends e.Resolvable{Bot(){this.addMiddleware(BotErrorMiddleware),this.addMiddleware(BotLoggingMiddleware),this.addMiddleware(BotEventMiddleware),this.addMiddleware(BotStateMiddleware),this.addMiddleware(BotRoutingMiddleware)}async route(e){let t=B.get(e)||0;return t?(t++,B.set(e,t),new Promise((t,o)=>{setImmediate(()=>{this.middleware.compose(this,e).then(t,o)})})):(t=1,B.set(e,t),this.middleware.compose(this,e))}async invoke(e){const t=await this.route(e);if(t instanceof DialogRouteAction)return e.path="",SetBotContextData(e,t.data),this.invoke(e);const o=e.getAgent(BotStateService);return o&&await o.save(),t}addMiddleware(e){this.middleware.push(e)}addDialog(e){this.dialog.add(e,this.handler)}addDialogs(e){for(const t of Object.keys(e))this.addDialog(e[t])}}__decorate([t.singleton(),__metadata("design:type",BotDialogRouter)],Bot.prototype,"dialog",void 0),__decorate([t.singleton(),__metadata("design:type",class BotDialogEventHandler extends BotService{beforeMiddleware(e,t,o){const r=this.makeMiddlewareSignature(o);return this.logger.debug(`(*) ${e.path} => ${o.declaringType.name}::${o.name}(${r})`),!0}beforeDialog(e,t,o){const r=this.makeMethodSignature(o),n=e.path+t.name;return this.logger.debug(`BOT ${n} => ${o.declaringType.name}::${o.name}(${r})`),!0}makeMiddlewareSignature(e){return e.descriptor&&e.descriptor.value.length>2?"ctx, data, next":"ctx, next"}makeMethodSignature(e){return e.descriptor&&e.descriptor.value.length>1?"ctx, data":"ctx"}})],Bot.prototype,"handler",void 0),__decorate([t.transit(),__metadata("design:type",e.Chain)],Bot.prototype,"middleware",void 0);class BotMessage{get id(){throw new e.NotImplementedException("id")}get private(){throw new e.NotImplementedException("private")}get text(){throw new e.NotImplementedException("text")}get command(){throw new e.NotImplementedException("command")}get commandArgs(){throw new e.NotImplementedException("commandArgs")}}class BotIdentity extends e.Identity{}class BotEvent{}class TelegramBotEventFactory{static normalizeUpdate(t){const o=t.channelData||t;let r,n,i,a,s,l,d,c,p,u=[];if(o.message)(a=o.message).text?i="message/text":a.voice?i="message/voice":a.photo?i="message/photo":a.document?i="message/document":a.location?i="message/location":a.sticker?i="message/sticker":a.new_chat_participant?(i="event/join_chat",s=a.new_chat_participant):a.left_chat_member?(i="event/left_chat",s=a.left_chat_participant):i=a.new_chat_title?"event/new_chat_title":a.new_chat_photo?"event/new_chat_photo":a.successful_payment?"event/payment":"message";else if(o.callback_query)i="event/callback",p=a=o.callback_query.message,c=o.callback_query.data;else if(o.channel_post)i="event/post",a=o.channel_post;else if(o.edited_message)i="event/edit_message",a=o.edited_message;else if(o.edited_message)i="event/edit_post",a=o.edited_channel_post;else{if(!o.pre_checkout_query)throw new e.Exception(o,"Unknown message type");{const e=o.pre_checkout_query;r=e.id,i="event/checkout";const t=e.from;l={id:t.id,type:"private",name:t.username,displayName:t.last_name?t.first_name+" "+t.last_name:t.first_name,isPrivate:!0,isGroup:!1,isChannel:!1},a=e,c=e.invoice_payload,n=new Date}}if(a){r||(r=a.message_id);const e=a.chat;!l&&e&&(l={id:e.id,type:e.type,name:e.username,displayName:e.title||(e.last_name?e.first_name+" "+e.last_name:e.first_name),isPrivate:"private"===e.type,isGroup:"group"===e.type,isChannel:"channel"===e.type}),s||(s=a.from),c||(c=a.text,u=a.entities),p||(delete(p=Object.assign({},a)).message_id,delete p.chat,delete p.from,delete p.date,delete p.text,delete p.entities),a.edit_date?n=new Date(1e3*a.edit_date):a.date&&(n=new Date(1e3*a.date))}if(s){let e=`${s.first_name}`;s.last_name&&(e+=` ${s.last_name}`),d={id:s.id,name:s.username,firstName:s.first_name,lastName:s.last_name,displayName:e,locale:s.language_code,bot:s.is_bot}}return[r,i,n||new Date,l,d,"telegram",o,void 0,p,c,u]}}class TelegramBotEvent extends BotEvent{constructor(e,t,o,r,n,i,a,s,l,d,c){super(),this.id=e,this.type=t,this.timestamp=o,this.chat=r,this.sender=n,this.provider=i,this.providerData=a,this.message=s,this.data=l,this.text=d,this.textEntities=c}static[t.ClassInitializer](e,t){return Reflect.construct(this,TelegramBotEventFactory.normalizeUpdate(t[0]))}}class BotProfile{}class TelegramBotIdentity extends BotIdentity{constructor(e,t,o,r,n,i){super(),this.id=e,this.address=t,this.timezone=o,this.locale=r,this.user=n,this.profile=i}static[t.ClassInitializer](e){const t=e.getAgentOrThrow(BotProfile),r=e.getAgentOrThrow(BotEvent);let n,i,a,s,l,d;if(n=String(r.chat.id),i="/telegram/bot/"+t.id+"/chat/"+r.chat.id,r.sender){const t=o.CreateHashedId([r.sender.id,"3fdeba596a7d938a05c38daf"]).toHexString();a=t,s={_id:t,id:r.sender.id,name:r.sender.name,displayName:r.sender.displayName,displayImageURL:""},d=r.sender.locale||e.settings.LOCALE}else d=e.settings.LOCALE;return l=e.settings.TIMEZONE,Reflect.construct(this,[n,i,l,d,a,s])}}function buildCommand(e){let t,o=[];if(e.text&&Array.isArray(e.textEntities))for(const r of e.textEntities)if("bot_command"===r.type){t=e.text.slice(r.offset,r.offset+r.length);const n=e.text.slice(r.offset+r.length).trim();o=n?n.split(" "):[]}return[t,o]}class TelegramBotMessage extends BotMessage{constructor(){super();const o=t.FindDomain(new.target,arguments);if(!o)throw new Error("NotAllowedToCreateTelegramBotEventMessage");const r=o.getAgent(TelegramBotEvent);if(!r)throw new Error("NotAllowedToCreateTelegramBotEventMessageWithoutTelegramBotEvent");e.set(this,"event",r)}get id(){return this.event.id}get private(){return this.event.chat.isPrivate}get text(){return this.event.text}get command(){const[t,o]=buildCommand(this.event);return e.set(this,"commandArgs",o),e.set(this,"command",t)}get commandArgs(){const[t,o]=buildCommand(this.event);return e.set(this,"command",t),e.set(this,"commandArgs",o)}}class TelegramBotContext extends BotContext{sendText(e,t){return this.telegram.sendText(t||this.event.chat.id,e)}sendTextWithAction(e,t,o){return this.telegram.sendText(o||this.event.chat.id,e,{reply_markup:{inline_keyboard:[[{text:"yes",callback_data:"cb123456"}]]}})}replyText(e,t,o){return this.telegram.sendText(o||this.event.chat.id,e,{reply_to_message_id:t||this.message.id})}sendTextWithKeyboard(){}}__decorate([t.singleton(),__metadata("design:type",BotProfile)],TelegramBotContext.prototype,"bot",void 0),__decorate([t.singleton(),__metadata("design:type",TelegramBotIdentity)],TelegramBotContext.prototype,"identity",void 0),__decorate([t.singleton(),__metadata("design:type",TelegramBotEvent)],TelegramBotContext.prototype,"event",void 0),__decorate([t.singleton(),__metadata("design:type",TelegramBotMessage)],TelegramBotContext.prototype,"message",void 0),__decorate([t.singleton(),__metadata("design:type",Telegram)],TelegramBotContext.prototype,"telegram",void 0);class TelegramBot extends Bot{}class TelegramBotProfile extends BotProfile{constructor(e,t,o,r){super(),this.id=e,this.username=t,this.displayName=o,this.displayImageURL=r}static[t.ClassInitializer](e,t){return Reflect.construct(this,t)}}exports.TelegramBotController=class TelegramBotController extends WebFoundationController{constructor(){super(...arguments),this.token=this.telegramBotSettings.TELEGRAM_BOT_TOKEN}async setup(e){const t=await e.resolve(Telegram),o=u.Reflector(this.constructor).getOwnAttributes(n.ControllerAttribute)[0];if(!o)throw new Error("not found bot route");const r=e.publicURL||this.settings.PUBLIC_URL;if(!r)throw new Error("unable to resolve public url");const i=a.resolve(r,`${o.path}/update/${this.token}`),s=await t.setupWebhook(i);return{bot:await t.getMe(),hook:s}}async update(e){if(!e.params.token)throw new n.BadRequestError("Missing bot token for telegram");if(this.token!==e.params.token)throw new n.BadRequestError("Invalid bot token");const t=this.telegramBotSettings.TELEGRAM_BOT_ID,o=this.telegramBotSettings.TELEGRAM_BOT_NAME,r=this.telegramBotSettings.TELEGRAM_BOT_DISPLAY_NAME||e.settings.NAME;return e.json().then(n=>(console.log("UPDATE = ",JSON.stringify(n,null,2)),e.resolve(TelegramBotProfile,[t,o,r]).then(t=>e.resolve(TelegramBotEvent,[n]).then(t=>(console.log("EVENT = ",t),e.resolve(TelegramBotContext).then(e=>this.bot.invoke(e))))))).then(t=>{t&&e.logger.trace("ignore bot response")}).catch(t=>{e.logger.error(t,"Unable to parse telegram request")})}},__decorate([t.singleton(),__metadata("design:type",TelegramBotSettings)],exports.TelegramBotController.prototype,"telegramBotSettings",void 0),__decorate([t.singleton(TelegramBot),__metadata("design:type",Bot)],exports.TelegramBotController.prototype,"bot",void 0),__decorate([n.method("GET","/setup"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],exports.TelegramBotController.prototype,"setup",null),__decorate([n.method("POST","/update/:token"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],exports.TelegramBotController.prototype,"update",null),exports.TelegramBotController=__decorate([n.controller("/api/integration/telegram/bot")],exports.TelegramBotController);class WechatBotSettings extends e.Settings{}__decorate([e.optional(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_ID",void 0),__decorate([e.optional(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_NAME",void 0),__decorate([e.optional(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_DISPLAY_NAME",void 0),__decorate([e.optional(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_TOKEN",void 0),__decorate([e.optional(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_SECRET_TOKEN",void 0),__decorate([e.optional(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_SECRET_KEY",void 0),__decorate([e.optional(),__metadata("design:type",Number)],WechatBotSettings.prototype,"WECHAT_BOT_DIALOG_TIMEOUT_IN_SECONDS",void 0),exports.WechatBotController=class WechatBotController extends WebFoundationController{async checkSender(e,t){const o=e.construct(WechatBotSettings),r=[e.query.nonce,e.query.timestamp,o.WECHAT_BOT_SECRET_TOKEN].join(""),n=p.createHash("sha1");n.update(r);const i=n.digest().toString("hex");return console.log("current",i),console.log("giving",e.query.signature),console.log("params",e.params),console.log("query",e.query),console.log("body",await e.text()),"GET"===e.method&&i!==e.query.signature?(e.logger.error("InvalidSignature"),""):t()}async verify(e){return e.query.echostr}async update(e){return`\n<xml>\n  <ToUserName><![CDATA[ostx3t918MejplFTMcWTD1erZkHY]]></ToUserName>\n  <FromUserName><![CDATA[gh_6c8b7f4f2e73]]></FromUserName>\n  <CreateTime>${Date.now()}</CreateTime>\n  <MsgType><![CDATA[text]]></MsgType>\n  <Content><![CDATA[你好]]></Content>\n</xml>`}},__decorate([n.middleware(),__metadata("design:type",Function),__metadata("design:paramtypes",[Object,Function]),__metadata("design:returntype",Promise)],exports.WechatBotController.prototype,"checkSender",null),__decorate([n.method("GET","/update/:token"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],exports.WechatBotController.prototype,"verify",null),__decorate([n.method("POST","/update/:token"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],exports.WechatBotController.prototype,"update",null),exports.WechatBotController=__decorate([n.controller("/api/integration/wechat/bot")],exports.WechatBotController),exports.WebFileController=class WebFileController{async token(t){const r=await this.WebFile.findTokenById(t,t.params.id);if(!r)throw new n.NotFoundError;const i=e.Base58.fromBytes(o.CreateHashedId(r.file)),a=t.headers.get("if-none-match");if(a&&a===i)t.body=null,t.status=304;else{const e=await this.WebFile.findFileById(t,r.file);if(!e)throw new n.NotFoundError;t.body=e.data,t.setHeader("etag",i),t.setHeader("content-type",e.type),t.setHeader("content-length",`${e.byteLength}`),t.status=200}}},__decorate([t.singleton(),__metadata("design:type",WebFileService)],exports.WebFileController.prototype,"WebFile",void 0),__decorate([n.method("GET","/token/:id"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],exports.WebFileController.prototype,"token",null),exports.WebFileController=__decorate([n.controller("/api/file")],exports.WebFileController);exports.AuthenticationSettings=AuthenticationSettings,exports.BitBucketSettings=BitBucketSettings,exports.Bot=Bot,exports.BotContext=BotContext,exports.BotEvent=BotEvent,exports.BotIdentity=BotIdentity,exports.BotMessage=BotMessage,exports.BotSettings=class BotSettings extends e.Settings{},exports.BotStateModel=BotStateModel,exports.BotStateService=BotStateService,exports.CurrentUser=CurrentUser,exports.ExternalFetcher=ExternalFetcher,exports.ExternalProviderService=ExternalProviderService,exports.ExternalUserService=ExternalUserService,exports.GitHubSettings=GitHubSettings,exports.SessionModel=class SessionModel extends i.Model{},exports.StorageBackedBotStateService=class StorageBackedBotStateService extends BotStateService{StorageBackedBotStateService(e,t){this.id=e,this.model=t,this.history=this.model.stack||[]}static async[t.ClassInitializer](t,r){const n=await t.resolve(exports.BotStateCollection),i={app:t.event.provider,bot:t.bot.id,chat:t.event.chat.id};t.event.sender&&(i.sender=t.event.sender.id);const a=o.CreateHashedId([i.app,i.bot,i.chat,i.sender]);let s=await n.getOne(a);if(s||(s=await n.insertOne(a,{...i,stack:[],state:{}})),!s)throw new Error("UnableCreateState");return e.set(t,"state",s.state),Reflect.construct(this,[a,s,t])}async save(){return(await this.resolve(exports.BotStateCollection)).updateOne(this.id,{stack:this.history,state:this.parent.state}).then(e=>{e||this.logger.error({dialog:this.id},"Unable to save dialog state")})}},exports.Telegram=Telegram,exports.TelegramBot=TelegramBot,exports.TelegramBotContext=TelegramBotContext,exports.TelegramBotEvent=TelegramBotEvent,exports.TelegramBotIdentity=TelegramBotIdentity,exports.TelegramBotMessage=TelegramBotMessage,exports.TelegramBotSettings=TelegramBotSettings,exports.UserCollection=UserCollection,exports.WebFileService=WebFileService,exports.WebFoundation=class WebFoundation extends n.WebModule{WebFoundation(){this.addController(exports.AuthenticationController),this.addController(exports.BasicAuthenticationController),this.addController(exports.BitBucketOpenIdAuthController),this.addController(exports.MicrosoftOpenIdAuthController),this.addController(exports.GitHubOpenIdAuthController),this.addController(exports.GitLabOpenIdAuthController),this.addController(exports.GoogleOpenIdAuthController),this.addController(exports.WeiboOpenIdAuthController),this.addController(exports.WebFileController),this.addController(exports.TelegramBotController),this.addController(exports.WechatBotController)}},exports.WebFoundationService=WebFoundationService,exports.WebFoundationSettings=WebFoundationSettings,exports.dialog=function dialog(e){return u.decorateClassMethod(new exports.DialogAttribute(e||""))};
//# sourceMappingURL=index.js.map
