/* Copyright 2019 Ling Zhang

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License. */

import{Settings as e,Id as t,Resolvable as o,IsAbsoluteURL as r,Exception as i,optional as n,MissingConfigurationValueError as a,Base58 as s,set as d,Container as l,NotSupportedException as c,PrefixTree as p,Chain as u,retry as _,NotImplementedException as g,Identity as h}from"@agentframework/container";import{singleton as m,extensible as y,ClassInitializer as f,attribute as v,TypeNotFoundError as I,transit as S,once as E,FindDomain as C}from"@agentframework/domain";import{GetTimestamp as w,IsExpired as O,CreateHashedId as T,StreamReader as b,Performance as B}from"@agentframework/utils";import{intersection as x}from"lodash";import{BadRequestError as U,WebRequestIdentityService as D,AuthenticationError as R,method as L,controller as A,WebContext as N,WebSettings as k,WebRequest as P,ControllerAttribute as G,MiddlewareAttribute as M,NotFoundError as F,middleware as W,WebModule as $}from"@agentframework/web";import{model as H,Model as j,DocumentCollection as q,BlobCollection as z,RecordCollection as K,collection as J}from"@agentframework/data";import{resolve as Y}from"url";import{stringify as V}from"querystring";import Q,{Headers as X}from"node-fetch";import{join as Z,resolve as ee}from"path";import{createHash as te}from"crypto";import{decorateClassMethod as oe,Reflector as re}from"@agentframework/core";class AuthenticationSettings extends e{constructor(){super(...arguments),this.WEB_SIGNIN_PATH="/authentication/signin",this.WEB_SIGNIN_SUCCESS_PATH="/authentication/validate",this.WEB_SIGNIN_FAILED_PATH="/authentication/failed",this.WEB_ACCESS_DENIED_PATH="/authentication/access_denied",this.WEB_SIGNOUT_PATH="/authentication/signout",this.WEB_SIGNOUT_COMPLETE_PATH="/"}}function __decorate(e,t,o,r){var i,n=arguments.length,a=n<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,o):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,o,r);else for(var s=e.length-1;s>=0;s--)(i=e[s])&&(a=(n<3?i(a):n>3?i(t,o,a):i(t,o))||a);return n>3&&a&&Object.defineProperty(t,o,a),a}function __metadata(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}let ie=class SessionService{async CreateSession(e,t){const o={...t,session:this.CreateNewSessionId(e),token:this.CreateNewTokenId(e)};return this.IdentityService.setIdentityData(e,o),Promise.resolve(o)}async ExtendSessionToken(e,t,o){if(e.identity.session!==t)throw new U("UnableToUpdateOtherSession");if(e.identity.token!==o)throw new U("UnableToUpdateOtherToken");const r=this.IdentityService.getIdentityData(e);if(!r)throw new U("NoSessionDataToExtend");return r.token=this.CreateNewTokenId(e),this.IdentityService.setIdentityData(e,r),r.token}async UpdateSession(e,t,o){if(e.identity.session!==t)throw new U("UnableToUpdateOtherSession");const r=this.IdentityService.getIdentityData(e);if(r){const t=this.CreateNewTokenId(e);r.token=t,o&&o.profile&&(r.profile=o.profile),this.IdentityService.setIdentityData(e,r)}return r}async TerminateSession(e,t,o){return t===e.identity.session&&this.IdentityService.clearIdentityData(e),!0}CreateNewSessionId(e){return e.construct(t,[],!0).toHexString()}CreateNewTokenId(e){const o=e.settings.WEB_TOKEN_EXPIRES_IN_MILLISECONDS,r=Date.now()+o;return e.construct(t,[r],!0).toHexString()}};__decorate([m(),__metadata("design:type",D)],ie.prototype,"IdentityService",void 0),ie=__decorate([y()],ie);let ne=class AuthenticationService{async IsAuthenticated(e){const t=e.identity.token,o=e.identity.session;if(!t||!o)return!1;const r=w(t);return!isNaN(r)&&(r>Date.now()||!(r+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS<Date.now())&&this.Sessions.ExtendSessionToken(e,o,t).then(()=>!0).catch(t=>(e.logger.warn(t,`Failed to extend session ${o}`),!1)))}async Authenticate(e,t,o){const r=e.identity;if(e.state.new_device_id)throw new Error("Unable to authenticate without cookie support at client side");r.session&&!O(r.token)&&(e.settings.DEBUG&&e.logger.debug({session:r.session},"Automatically log out for incoming authentication"),await this.Sessions.TerminateSession(e,r.session,"Re-authenticate"));const i={roles:o?x(t.roles||[],o):t.roles||[],groups:t.groups||[],profile:{_id:t._id.toHexString(),displayName:t.displayName,displayImageURL:t.displayImageURL}};return t.timezone&&t.timezone!==e.settings.TIMEZONE&&(i.timezone=t.timezone),t.locale&&t.locale!==e.settings.LOCALE&&(i.timezone=t.locale),t.currency&&t.currency!==e.settings.CURRENCY&&(i.timezone=t.currency),t.theme&&t.theme!==e.settings.THEME&&(i.timezone=t.theme),this.Sessions.CreateSession(e,i)}async GetStatus(e){const t=await this.IsAuthenticated(e),o=e.identity;let r,i;return t&&(r={issue:w(o.session),type:2},o.profile&&(i={id:o.profile.id,username:o.profile.username,displayName:o.profile.displayName,displayImageURL:o.profile.displayImageURL})),i||(i={displayName:"Guest"}),i.roles=o.roles,i.groups=o.groups,o.timezone!==e.settings.TIMEZONE&&(i.timezone=o.timezone),o.locale!==e.settings.LOCALE&&(i.locale=o.locale),o.currency!==e.settings.CURRENCY&&(i.currency=o.currency),o.theme!==e.settings.THEME&&(i.theme=o.theme),{auth:t,session:r,profile:i}}async Update(e,t){const o=t._id.toHexString();if(e.identity.user!==o)throw new Error("Unable to update signed in user to another user");return this.Sessions.UpdateSession(e,o,{timezone:t.timezone!==e.settings.TIMEZONE?t.timezone:void 0,locale:t.locale!==e.settings.LOCALE?t.locale:void 0,currency:t.currency!==e.settings.CURRENCY?t.currency:void 0,theme:t.theme!==e.settings.THEME?t.theme:void 0,roles:t.roles,groups:t.groups,profile:{_id:o,displayName:t.displayName,displayImageURL:t.displayImageURL}}).then(()=>!0).catch(()=>!1)}async SignOut(e,t="SignOut"){return!!e.identity.session&&this.Sessions.TerminateSession(e,e.identity.session,t)}};__decorate([m(),__metadata("design:type",ie)],ne.prototype,"Sessions",void 0),ne=__decorate([y()],ne);let ae=class UserModel extends j{};ae=__decorate([H("user")],ae);class UserCollection extends q{constructor(){super(ae)}}let se=class BasicAuthenticationController{async SignUp(e){let{displayName:t,id:o,password:r}=await e.json();if(!o)throw new U("MissingUserId");if("string"!=typeof o)throw new U("InvalidUserId");if(!r)throw new U("MissingUserPassword");if("string"!=typeof r)throw new U("InvalidUserPassword");if("string"!=typeof t)throw new U("InvalidDisplayName");if(r){r=require("bcryptjs").hashSync(r,10)}return(await e.resolve(UserCollection)).insertOne(o,{displayName:t,password:r})}async SignIn(e){const{id:t,password:o}=await e.json();if(!t)throw new R("MissingUserId");if("string"!=typeof t)throw new R("InvalidUserId");if(!o)throw new R("MissingUserPassword");if("string"!=typeof o)throw new R("InvalidUserPassword");const r=e.construct(AuthenticationSettings),i=await e.resolve(UserCollection),n=await i.getOne(t);if(!n)throw new R("UserNotFound");if(!require("bcryptjs").compareSync(o,n.password))throw new R("IncorrectUserPassword");return this.Authenticator.Authenticate(e.req,n).then(t=>{if(t){const t=r.WEB_SIGNIN_SUCCESS_PATH;if(t)return e.redirect(t)}else{const t=r.WEB_SIGNIN_FAILED_PATH;if(t)return e.redirect(t)}}).catch(e=>{throw new R(e)})}};__decorate([m(),__metadata("design:type",ne)],se.prototype,"Authenticator",void 0),__decorate([L("POST","/signup"),__metadata("design:type",Function),__metadata("design:paramtypes",[N]),__metadata("design:returntype",Promise)],se.prototype,"SignUp",null),__decorate([L("POST","/signin"),__metadata("design:type",Function),__metadata("design:paramtypes",[N]),__metadata("design:returntype",Promise)],se.prototype,"SignIn",null),se=__decorate([A("/api/auth")],se);let de=class AuthenticationController{async Status(e){return this.Authenticator.GetStatus(e.req)}async SignOut(e){await this.Authenticator.SignOut(e.req);const t=e.construct(AuthenticationSettings).WEB_SIGNOUT_COMPLETE_PATH;if(t)return e.redirect(t);const o=e.settings.HOME_URL;if(o)return e.redirect(o);const r=e.settings.PUBLIC_URL;return r?e.redirect(r):void 0}};__decorate([m(),__metadata("design:type",ne)],de.prototype,"Authenticator",void 0),__decorate([L("GET","/auth/status"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],de.prototype,"Status",null),__decorate([L("GET","/signout"),__metadata("design:type",Function),__metadata("design:paramtypes",[N]),__metadata("design:returntype",Promise)],de.prototype,"SignOut",null),de=__decorate([A("/api")],de);class SessionModel extends j{}let le=class EmailModel extends j{};le=__decorate([H("email")],le);class EmailCollection extends q{constructor(){super(le)}}class WebFoundationService extends o{}class WebFoundationSettings extends k{constructor(){super(...arguments),this.WEB_INVITATION_EXPIRES_IN_MILLISECONDS=12096e5,this.WEB_EMAIL_VERIFICATION_RESEND_INTERVAL_IN_MILLISECONDS=6e4,this.WEB_EMAIL_VERIFICATION_EXPIRES_IN_MILLISECONDS=216e5}}class UserService extends WebFoundationService{async findOneById(e,t){return(await e.resolve(UserCollection)).getOne(t)}async isEmailBeenUsed(e,t){const o=await e.resolve(EmailCollection),r=T(t.trim().toLowerCase());return o.getOne(r).then(e=>!!e)}async isMobileExists(e,t){return!1}async findUserFromEmail(e,o){const r=await e.resolve(EmailCollection),i=T(o.trim().toLowerCase()),n=await r.getOne(i);if(n&&n.user)return(await e.resolve(UserCollection)).getOne(new t(n.user))}async findOrCreateUserFromExternalUser(e,t){const o=await e.resolve(UserCollection),r=await e.resolve(EmailCollection),i=t._id,n=await o.getOne(i);if(n)return n;if(t.user){const e=await o.getOne(t.user);if(e)return e}const a={displayName:t.displayName,displayImageURL:t.displayImageURL||"",roles:["user"]};if(t.email&&t.emailCertified){const o=e.construct(WebFoundationSettings).ADMIN_EMAIL;o&&"string"==typeof o&&t.email===o&&a.roles.push("admin")}t.locale&&(a.locale=t.locale);const s=await o.insertOne(i,a);if(!s)throw new Error("Unable to create external user");if(t.email&&t.emailCertified){const o=T(t.email.trim().toLowerCase()),i=new le;i.name=t.email,i.displayName=t.displayName,i.user=s._id.toHexString(),await r.insertOne(o,i)||e.logger.warn({user:s._id,email:i.name})}return s}}class CurrentUser extends ae{static async[f](e){if(!(e instanceof P))throw new Error("CurrentUser is only resolvable from ctx scope");const o=e.identity.user;if(o&&t.IsValid(o))return e.resolve(UserService).then(t=>t.findOneById(e,o).then(e=>{if(!e)throw new Error("NoCurrentUser");return Reflect.setPrototypeOf(e,CurrentUser.prototype),e}));throw new Error("NoCurrentUser")}}class WebFoundationController extends o{getFailureURL(e,t){return e.logger.error(t),"/#"+e.construct(AuthenticationSettings).WEB_SIGNIN_FAILED_PATH}}let ce=class ExternalUserModel extends j{};ce=__decorate([H("external_user")],ce);class ExternalUserCollection extends q{constructor(){super(ce)}}let pe=class ExternalTokenModel extends j{};pe=__decorate([H("external_token")],pe);class ExternalTokenCollection extends q{constructor(){super(pe)}}class ExternalUserService extends WebFoundationService{async updateToken(e,t,o){return(await e.resolve(ExternalTokenCollection)).replaceOne(o._id,t)}async connectUser(e,t,o){return(await e.resolve(ExternalUserCollection)).mergeOne(t._id,{user:o._id})}async findOrCreateExternalUser(e,t){const o=await e.resolve(ExternalUserCollection),r=T([t.uid,t.providerId]);let i=await o.getOne(r);if(i)return i;i=new ce,Object.assign(i,t);const n=await o.insertOne(r,i);if(!n)throw new Error("Unable to create external user");return n}async findOrCreateOrUpdateDifferenceExternalUser(e,t){const o=await e.resolve(ExternalUserCollection),r=T([t.uid,t.providerId]);let i=await o.getOne(r),n=!1;if(i){for(const e of Object.keys(t))if(i[e]!=t[e]&&"object"!=typeof t[e]){n=!0;break}if(!n)return i}const a=i||new ce;return Object.assign(a,t),n?o.mergeOne(r,a).then(e=>{if(!e)throw new Error("Unable to merge external user");return a}):o.insertOne(r,a).then(e=>{if(!e)throw new Error("Unable to create external user");return e})}}class ExternalFetcher{constructor(e){if(e&&e.baseURL&&!r(e.baseURL))throw new i({baseURL:e.baseURL},"Invalid fetch base url");this.defaults=e||{}}makeFetchOptions(e={}){const t=Object.assign({},this.defaults.query,e.query||{}),o=Object.assign({},this.defaults.headers,e.headers||{}),n=Object.assign({},e),a=n.headers=new X(o);let s;if(n.url&&r(n.url))s=new URL(n.url);else{if(!this.defaults.baseURL)throw new i({url:n.url},"Invalid fetch url");s=new URL(this.defaults.baseURL+n.url)}for(const e of Object.keys(t))s.searchParams.append(e,t[e]);if(n.data){const e=(a.get("content-type")||"").toString().toLowerCase();e.startsWith("application/json")?n.body=JSON.stringify(n.data):e.startsWith("application/x-www-form-urlencoded")?n.body=V(n.data):n.body=n.data,"string"==typeof n.body&&a.set("content-length",String(n.body.length))}return delete n.url,delete n.query,delete n.data,{url:s.toString(),init:n}}httpRequest(e){const{url:t,init:o}=this.makeFetchOptions(e);return Q(t,o).then(async e=>{const t={url:e.url,status:e.status,statusText:e.statusText,headers:e.headers,type:e.headers.get("content-type")||"application/octet-stream",body:new b(e.body)};return t.type.startsWith("application/json")&&(t.data=await t.body.json()),t})}httpPost(e,t,o={}){return o.method="POST",o.url=e,o.data=t,this.httpRequest(o)}httpPut(e,t,o={}){return o.method="PUT",o.url=e,o.data=t,this.httpRequest(o)}httpGet(e,t={}){return t.method="GET",t.url=e,this.httpRequest(t)}httpGetAsText(e,t={}){return this.httpGet(e,t).then(e=>e.body.text())}httpGetAsBuffer(e,t={}){return this.httpGet(e,t).then(e=>e.body.buffer())}httpGetAsJson(e,t={}){return this.httpGet(e,t).then(e=>{if(null==e.data)throw new Error("ResponseIsNotJSON");return e.data})}httpDelete(e,t={}){return t.method="DELETE",t.url=e,this.httpRequest(t)}}class OAuth2Client extends ExternalFetcher{constructor(e){super({headers:{Accept:"application/json","Content-Type":"application/json"}}),this.options=e}authorizeURL(e){const t={client_id:this.options.client_id,response_type:"code"};Array.isArray(e.scope)&&(e.scope=e.scope.join(" "));const o=Object.assign({},t,e);return`${this.options.authorization_endpoint}?${V(o)}`}getToken(e){Array.isArray(e.scope)&&(e.scope=e.scope.join(" "));const t=Object.assign({},e,{client_id:this.options.client_id,client_secret:this.options.client_secret,grant_type:"authorization_code"});return super.httpPost(this.options.token_endpoint,t,{headers:{"Content-Type":"application/x-www-form-urlencoded"}}).then(e=>{if(!e.data)throw new Error("InvalidOAuthTokenResponseType");return e.data}).catch(e=>(console.log("errror get token",e),console.log("try get token using json payload",t),super.httpPost(this.options.token_endpoint,t)))}get(e){return super.httpGetAsJson(e)}}class OpenIdAuthenticator extends WebFoundationService{update(e){this.idProvider=e.provider,this.oauth=new OAuth2Client({client_id:e.appID,client_secret:e.appSecret,authorization_endpoint:e.authorization_endpoint,token_endpoint:e.token_endpoint}),e.scope?this.scope=e.scope:this.scope="openid"}getAuthorizeURL(e,t){return this.oauth.authorizeURL({redirect_uri:e,scope:this.scope,state:String(t)})}getSuccessURL(e){return"/#"+this.construct(AuthenticationSettings).WEB_SIGNIN_SUCCESS_PATH}getFailureURL(e){return"/#"+this.construct(AuthenticationSettings).WEB_SIGNIN_FAILED_PATH}getToken(e,t){return this.oauth.getToken({redirect_uri:e,code:t,scope:this.scope}).then(e=>{if(e.id_token&&"string"==typeof e.id_token)try{const t=e.id_token.split("."),o=Buffer.from(t[1],"base64");e.id_token=JSON.parse(o.toString())}catch(t){e.id_token={},e.id_token_error=t.message}else e.id_token={},e.id_token_error="id_token is not found";return e})}async refreshToken(e){throw new Error("Not implemented refresh token")}async getUserProfile(e){const t=e.id_token;let o=[],r=null,i=null,n=null,a=!1;if(t.email&&(r=t.email,a=t.email_verified),r){const e=r.split("@");i=e[0],n=e[1]}return r&&a&&o.push({type:"email",value:r}),{uid:t.sub,providerData:null,identities:o,username:i,domain:n,email:r,emailCertified:a,mobile:null,mobileCertified:!1,displayName:t.name,displayImageURL:t.picture,familyName:t.family_name,givenName:t.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:t.locale}}}var ue,_e,ge;class OpenIdController extends WebFoundationController{OnProfile(e,t,o){return Promise.resolve(null)}async getAuthenticator(e){const t=e.construct(OpenIdAuthenticator),o=await this.discover(e);return t.update({provider:o,issuer:o.providerURL,appID:o.appID,appSecret:o.appSecret,token_endpoint:o.providerConfiguration.token_endpoint,authorization_endpoint:o.providerConfiguration.authorization_endpoint,scope:o.scope}),t}async[ue=Symbol("start")](e){let t;try{const o=await this.getAuthenticator(e),r=Y(e.publicURL,"callback");r.startsWith("http://")&&e.logger.error("Unsecured oauth callback url: "+r),t=o.getAuthorizeURL(r,Date.now())}catch(o){if(o instanceof SyntaxError)return""+o.message;t=await this.getFailureURL(e,new i(o,"Unable to start authentication"))}return e.redirect(t)}async[_e=Symbol("callback")](e){const o=Y(e.publicURL,"callback");o.startsWith("http://")&&e.logger.error("Unsecured oauth callback url: "+o);const r=Number(e.query.state),i=await this.getAuthenticator(e),n=i.idProvider;if(r>Date.now())e.redirect(i.getFailureURL(new U("InvalidAuthenticationState")));else{if(e.query.error){const t=new U(`${e.query.error}: ${e.query.error_description}`);return e.logger.error(t,"Authentication Error"),void e.redirect(i.getFailureURL(t))}try{const r=e.query.code,a=await i.getToken(o,r);let s=await this.OnProfile(e,a,n).catch(()=>null);if(s||(s=await i.getUserProfile(a).catch(()=>null)),!s||!s.uid){let t=new U("Unable to get unique user identity from provider");return e.logger.error(t),void e.redirect(i.getFailureURL(t))}s&&(Reflect.has(s,"user")&&(s.user&&t.IsValid(s.user)?e.logger.warn(`External user ${s.uid}@${n._id} already set the user field to ${s.user}`):delete s.user),s.displayImageURL||e.logger.warn(`External user ${s.uid}@${n._id} do not have a profile image`),s.provider=n.provider,s.providerProtocol=n.providerProtocol,s.providerURL=n.providerURL,s.providerId=n._id.toString());const d=await this.ExternalUsers.findOrCreateOrUpdateDifferenceExternalUser(e,s);let l;await this.ExternalUsers.updateToken(e,a,d),l=d.user?await this.Users.findOneById(e,d.user):d.email&&d.emailCertified?await this.Users.findUserFromEmail(e,d.email):void 0;const c=await e.resolve(CurrentUser).catch(()=>void 0),p=await this.OnAuthenticated(e,n,a,d,l,c);e.redirect(i.getSuccessURL(p))}catch(t){e.logger.error(t,"Authentication Callback Error"),e.redirect(i.getFailureURL(t))}}}}__decorate([m(),__metadata("design:type",ExternalUserService)],OpenIdController.prototype,"ExternalUsers",void 0),__decorate([m(),__metadata("design:type",UserService)],OpenIdController.prototype,"Users",void 0),__decorate([L("GET","/start"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],OpenIdController.prototype,ue,null),__decorate([L("GET","/callback"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],OpenIdController.prototype,_e,null),function(e){e.SIGN_UP="sign-up",e.SIGN_UP_FAILED="sign-up-failed",e.SIGN_IN="sign-in",e.SIGN_IN_FAILED="sign-in-failed",e.SIGN_OUT="sign-out",e.SESSION_EXPIRED="session-expired",e.ACCESS_DENIED="access-denied"}(ge||(ge={}));let he=class EventModel extends j{};he=__decorate([H("event")],he);class EventCollection extends q{constructor(){super(he)}}class OpenIdConnect extends ExternalFetcher{constructor(){super(...arguments),this.ConfigurationEndpoint="/.well-known/openid-configuration"}discovery(e){e.pathname=Z(e.pathname,this.ConfigurationEndpoint);const t=e.toString();return super.httpGetAsJson(t)}static[f](e,t){return Reflect.construct(this,t)}}let me=class ExternalProviderModel extends j{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):"{}",expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):"{}"}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}};me=__decorate([H("external_provider")],me);class ExternalProviderCollection extends q{constructor(){super(me)}}class ExternalProviderService extends WebFoundationService{async findOrResolveExternalProvider(e,t){const o=this.createProviderId(t),r=await e.resolve(ExternalProviderCollection),i=await r.getOne(o);if(i){if(i.providerConfiguration)return i;if(i.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL),!i.providerConfiguration)throw new Error("Unable to discover external id provider");return r.mergeOne(o,i).then(e=>i)}if(t.providerConfiguration||(t.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL)),!t.providerConfiguration)throw new Error("Unable to discover external id provider");return r.insertOne(o,t).then(e=>{if(!e)throw new Error("Unable to create external provider");return e})}createProviderId(e){const t=[String(e.provider),String(e.providerProtocol),String(e.providerURL)];return e.appID&&t.push(String(e.appID)),T(t)}async discoverProviderConfiguration(e,t){let o;try{o=new URL(t)}catch(e){throw new i(e,"Invalid external provider: "+t)}return"https:"!==o.protocol&&e.logger.warn("Unsecured external id provider: "+t),e.construct(OpenIdConnect).discovery(o).catch(t=>(e.logger.warn(t,{issuer:o},"Unable to discover the configuration"),null))}}class OpenIdAuthController extends OpenIdController{discover(e){return this.OpenIdProfile.discover(e)}async OnProfile(e,t,o){return this.OpenIdProfile.getUserProfile(e,t,o)}async OnAuthenticated(e,t,o,r,i,n){if(i){const o=await this.Authenticator.Authenticate(e.req,i);return o&&(e.logger.debug({user:i._id,email:r.email,roles:i.roles&&i.roles.join(","),session:o.session},`Logged in with ${t.displayName}`),await this.Events.createSignInEvent(e.req,t,i)),i}if(r.email){if(await this.Users.isEmailBeenUsed(e,r.email))throw new R(`Email ${r.email} is already been used`)}const a=await this.Users.findOrCreateUserFromExternalUser(e,r);if(!a)throw new R({provider:t.provider,providerProtocol:t.providerProtocol,providerId:t._id},`Failed to register user ${r.uid}`);return await this.ExternalUsers.connectUser(e,r,a)||e.logger.error({external_user:r._id,new_created_user:a._id},"Unable to connect external user to new created user"),this.Authenticator.Authenticate(e.req,a).then(o=>o?(e.logger.debug({user:a._id,email:r.email,roles:a.roles&&a.roles.join(","),session:o.session},`First time logged in with ${t.displayName}`),this.Events.createSignUpEvent(e.req,t,a).then(()=>a)):a)}}__decorate([m(),__metadata("design:type",class EventService extends WebFoundationService{async createUserEvent(e,o,r,i){const n={provider:o.displayName,providerId:o._id,user:{_id:r._id,displayName:r.displayName,displayImageURL:r.displayImageURL}},a=await e.resolve(EventCollection),s=new he;return s.type=i,s.context=n,a.insertOne(e.construct(t,[],!0),s)}async getLatestEvents(e){return[]}async createSignInEvent(e,t,o){return this.createUserEvent(e,t,o,ge.SIGN_IN)}async createSignUpEvent(e,t,o){return this.createUserEvent(e,t,o,ge.SIGN_UP)}async SignOut(e,t,o){return this.createUserEvent(e,t,o,ge.SIGN_OUT)}})],OpenIdAuthController.prototype,"Events",void 0),__decorate([m(),__metadata("design:type",ne)],OpenIdAuthController.prototype,"Authenticator",void 0),__decorate([m(),__metadata("design:type",ExternalProviderService)],OpenIdAuthController.prototype,"ExternalProvider",void 0);class WeiboSettings extends e{}__decorate([n(),__metadata("design:type",Boolean)],WeiboSettings.prototype,"OIDC_WEIBO",void 0),__decorate([n(),__metadata("design:type",String)],WeiboSettings.prototype,"OIDC_WEIBO_ISSUER_URL",void 0),__decorate([n(),__metadata("design:type",String)],WeiboSettings.prototype,"OIDC_WEIBO_CLIENT_ID",void 0),__decorate([n(),__metadata("design:type",String)],WeiboSettings.prototype,"OIDC_WEIBO_CLIENT_SECRET",void 0),__decorate([n(),__metadata("design:type",Array)],WeiboSettings.prototype,"OIDC_WEIBO_SCOPES",void 0);class Weibo extends ExternalFetcher{constructor(e){if(super({baseURL:"https://api.weibo.com",query:{access_token:e}}),!e)throw new Error("Access token can not be null or empty")}get(e,t){return super.httpGetAsJson(e,t)}post(e,t,o){return super.httpPost(e,t,o)}comments(e={}){return this.get("/2/comments/to_me.json",e)}mentions(e={}){return this.get("/2/comments/mentions.json",e)}reposts(e={}){return this.get("/2/statuses/mentions.json",e)}weibo(e={}){return this.get("/2/statuses/home_timeline.json",e)}getLimits(){return this.get("/2/account/rate_limit_status.json",{})}}class WeiboOpenIdService{async discover(e){const t=e.construct(WeiboSettings);if(!t.OIDC_WEIBO)throw new Error("WeiboAuthIsNotEnabled");const o={provider:"weibo",providerProtocol:"oauth",providerURL:t.OIDC_WEIBO_ISSUER_URL,displayName:"Weibo Account",displayImageURL:"https://www.weibo.com/favicon.ico",providerConfiguration:{issuer:t.OIDC_WEIBO_ISSUER_URL,authorization_endpoint:"https://api.weibo.com/oauth2/authorize",token_endpoint:"https://api.weibo.com/oauth2/access_token",userinfo_endpoint:"https://api.weibo.com/2/users/show.json"}},r=await this.OpenIdProvider.findOrResolveExternalProvider(e,o),i=r.appID||t.OIDC_WEIBO_CLIENT_ID;if(!i)throw new a("OIDC_WEIBO_CLIENT_ID");const n=r.appSecret||t.OIDC_WEIBO_CLIENT_SECRET;if(!n)throw new a("OIDC_WEIBO_CLIENT_SECRET");return r.appID=i,r.appSecret=n,t.OIDC_WEIBO_SCOPES&&(r.scope=t.OIDC_WEIBO_SCOPES.join(" ")),r}async getUserProfile(e,t,o){if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const r=new Weibo(t.access_token),i=await r.post("https://api.weibo.com/oauth2/get_token_info",null);t.appkey=i.appkey;const n=await r.get(o.providerConfiguration.userinfo_endpoint,{query:{uid:t.uid}}).catch(e=>{throw console.log("unable to get weibot profile",e),e});return{uid:n.id,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:n,userData:{},identities:[],username:n.domain||null,domain:null,domainCertified:!1,email:null,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:n.screen_name,displayImageURL:n.profile_image_url,familyName:null,givenName:null,gender:n.gender,dob:null,status:n.status?n.status.text:null,bio:n.description,homepage:n.url||null,locale:n.lang}}}__decorate([m(),__metadata("design:type",ExternalProviderService)],WeiboOpenIdService.prototype,"OpenIdProvider",void 0);let ye=class WeiboOpenIdAuthController extends OpenIdAuthController{};__decorate([m(),__metadata("design:type",WeiboOpenIdService)],ye.prototype,"OpenIdProfile",void 0),ye=__decorate([A("/api/integration/weibo/auth")],ye);class BearerClient extends ExternalFetcher{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error("Access token can not be null or empty")}get(e,t){return super.httpGetAsJson(e)}post(e,t,o){return super.httpPost(e,t,o)}}class BitBucketSettings extends e{}__decorate([n(),__metadata("design:type",Boolean)],BitBucketSettings.prototype,"OIDC_BITBUCKET",void 0),__decorate([n(),__metadata("design:type",String)],BitBucketSettings.prototype,"OIDC_BITBUCKET_ISSUER_URL",void 0),__decorate([n(),__metadata("design:type",String)],BitBucketSettings.prototype,"OIDC_BITBUCKET_CLIENT_ID",void 0),__decorate([n(),__metadata("design:type",String)],BitBucketSettings.prototype,"OIDC_BITBUCKET_CLIENT_SECRET",void 0),__decorate([n(),__metadata("design:type",Array)],BitBucketSettings.prototype,"OIDC_BITBUCKET_SCOPES",void 0);class BitBucketProfileService{async discover(e){const t=e.construct(BitBucketSettings);if(!t.OIDC_BITBUCKET)throw new Error("BitBucketAuthIsNotEnabled");const o={provider:"bitbucket",providerProtocol:"openid",providerURL:t.OIDC_BITBUCKET_ISSUER_URL,displayName:"BitBucket Account",displayImageURL:"https://bitbucket.org/favicon.ico",providerConfiguration:{issuer:t.OIDC_BITBUCKET_ISSUER_URL,authorization_endpoint:"https://bitbucket.org/site/oauth2/authorize",token_endpoint:"https://bitbucket.org/site/oauth2/access_token",userinfo_endpoint:"https://api.bitbucket.org/2.0/user"}},r=await this.OpenIdProvider.findOrResolveExternalProvider(e,o),i=r.appID||t.OIDC_BITBUCKET_CLIENT_ID;if(!i)throw new a("OIDC_BITBUCKET_CLIENT_ID");const n=r.appSecret||t.OIDC_BITBUCKET_CLIENT_SECRET;if(!n)throw new a("OIDC_BITBUCKET_CLIENT_SECRET");return r.appID=i,r.appSecret=n,t.OIDC_BITBUCKET_SCOPES&&(r.scope=r.scope||t.OIDC_BITBUCKET_SCOPES.join(" ")),r}async getUserProfile(e,t,o){const r=new BearerClient(t.access_token),i=await r.get(o.providerConfiguration.userinfo_endpoint),n=await r.get("https://api.bitbucket.org/2.0/user/emails");let a="",s=!1;const d=[];if(n&&n.values)for(const e of n.values)"email"===e.type&&e.is_primary&&(a=e.email,s=e.is_confirmed);return a&&s&&d.push({type:"email",value:a}),{uid:i.account_id,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:i,userData:{},identities:d,username:i.nickname,domain:"",domainCertified:!1,email:a,emailCertified:s,mobile:"",mobileCertified:!1,displayName:i.display_name,displayImageURL:"",familyName:"",givenName:"",gender:null,dob:null,status:null,bio:"",homepage:i.website,locale:""}}}__decorate([m(),__metadata("design:type",ExternalProviderService)],BitBucketProfileService.prototype,"OpenIdProvider",void 0);let fe=class BitBucketOpenIdAuthController extends OpenIdAuthController{};__decorate([m(),__metadata("design:type",BitBucketProfileService)],fe.prototype,"OpenIdProfile",void 0),fe=__decorate([A("/api/integration/bitbucket/auth")],fe);class GoogleSettings extends e{}__decorate([n(),__metadata("design:type",Boolean)],GoogleSettings.prototype,"OIDC_GOOGLE",void 0),__decorate([n(),__metadata("design:type",String)],GoogleSettings.prototype,"OIDC_GOOGLE_ISSUER_URL",void 0),__decorate([n(),__metadata("design:type",String)],GoogleSettings.prototype,"OIDC_GOOGLE_CLIENT_ID",void 0),__decorate([n(),__metadata("design:type",String)],GoogleSettings.prototype,"OIDC_GOOGLE_CLIENT_SECRET",void 0),__decorate([n(),__metadata("design:type",Array)],GoogleSettings.prototype,"OIDC_GOOGLE_SCOPES",void 0);class GoogleProfileService{constructor(){this.TrustedEmailDomains=["gmail.com"]}async discover(e){const t=e.construct(GoogleSettings);if(!t.OIDC_GOOGLE)throw new Error("GoogleAuthIsNotEnabled");const o={provider:"google",providerProtocol:"openid",providerURL:t.OIDC_GOOGLE_ISSUER_URL,displayName:"Google Account",displayImageURL:"https://www.google.com/favicon.ico"},r=await this.OpenIdProvider.findOrResolveExternalProvider(e,o),i=r.appID||t.OIDC_GOOGLE_CLIENT_ID;if(!i)throw new a("OIDC_GOOGLE_CLIENT_ID");const n=r.appSecret||t.OIDC_GOOGLE_CLIENT_SECRET;if(!n)throw new a("OIDC_GOOGLE_CLIENT_SECRET");return r.appID=i,r.appSecret=n,t.OIDC_GOOGLE_SCOPES&&(r.scope=r.scope||t.OIDC_GOOGLE_SCOPES.join(" ")),r}async getUserProfile(e,t,o){const r=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const i=new BearerClient(t.access_token),n=await i.get(o.providerConfiguration.userinfo_endpoint).catch(()=>null);let a=[],s=null,d=null,l=null,c=!1;if(r.picture?l=r.picture:n&&n.picture&&(l=n.picture),r.email&&(s=r.email),s){const e=s.split("@");d=e[0],this.TrustedEmailDomains.indexOf(e[1].toLowerCase())>=0&&(c=r.email_verified)}return s&&c&&a.push({type:"email",value:s}),{uid:r.sub,provider:o.provider,providerProtocol:o.providerProtocol,providerId:o._id,providerData:n,userData:{},identities:a,username:d,domain:null,domainCertified:!1,email:s,emailCertified:c,mobile:null,mobileCertified:!1,displayName:r.name,displayImageURL:l,familyName:r.family_name,givenName:r.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:r.locale}}}__decorate([m(),__metadata("design:type",ExternalProviderService)],GoogleProfileService.prototype,"OpenIdProvider",void 0);let ve=class GoogleOpenIdAuthController extends OpenIdAuthController{};__decorate([m(),__metadata("design:type",GoogleProfileService)],ve.prototype,"OpenIdProfile",void 0),ve=__decorate([A("/api/integration/google/auth")],ve);class GitLabSettings extends e{}__decorate([n(),__metadata("design:type",Boolean)],GitLabSettings.prototype,"OIDC_GITLAB",void 0),__decorate([n(),__metadata("design:type",String)],GitLabSettings.prototype,"OIDC_GITLAB_ISSUER_URL",void 0),__decorate([n(),__metadata("design:type",String)],GitLabSettings.prototype,"OIDC_GITLAB_CLIENT_ID",void 0),__decorate([n(),__metadata("design:type",String)],GitLabSettings.prototype,"OIDC_GITLAB_CLIENT_SECRET",void 0),__decorate([n(),__metadata("design:type",Array)],GitLabSettings.prototype,"OIDC_GITLAB_SCOPES",void 0);class GitLabProfileService{async discover(e){const t=e.construct(GitLabSettings);if(!t.OIDC_GITLAB)throw new Error("GitLabAuthIsNotEnabled");const o={provider:"gitlab",providerProtocol:"openid",providerURL:t.OIDC_GITLAB_ISSUER_URL,displayName:"GitLab Account",displayImageURL:"https://about.gitlab.com/ico/favicon-192x192.png"},r=await this.OpenIdProvider.findOrResolveExternalProvider(e,o),i=r.appID||t.OIDC_GITLAB_CLIENT_ID;if(!i)throw new a("OIDC_GITLAB_CLIENT_ID");const n=r.appSecret||t.OIDC_GITLAB_CLIENT_SECRET;if(!n)throw new a("OIDC_GITLAB_CLIENT_SECRET");return r.appID=i,r.appSecret=n,t.OIDC_GITLAB_SCOPES&&(r.scope=r.scope||t.OIDC_GITLAB_SCOPES.join(" ")),r}async getUserProfile(e,t,o){const r=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const i=new BearerClient(t.access_token),n=await i.get(o.providerConfiguration.userinfo_endpoint);let a=[],s=n.picture;return n.email&&n.email_verified&&a.push({type:"email",value:n.email}),{uid:r.sub,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:n,userData:{},identities:a,username:n.nickname||null,domain:null,domainCertified:!1,email:n.email||null,emailCertified:n.email_verified||!1,mobile:null,mobileCertified:!1,displayName:r.name||n.name,displayImageURL:s,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:null,homepage:n.profile||null,locale:null}}}__decorate([m(),__metadata("design:type",ExternalProviderService)],GitLabProfileService.prototype,"OpenIdProvider",void 0);let Ie=class GitLabOpenIdAuthController extends OpenIdAuthController{};__decorate([m(),__metadata("design:type",GitLabProfileService)],Ie.prototype,"OpenIdProfile",void 0),Ie=__decorate([A("/api/integration/gitlab/auth")],Ie);class GitHubSettings extends e{}__decorate([n(),__metadata("design:type",Boolean)],GitHubSettings.prototype,"OIDC_GITHUB",void 0),__decorate([n(),__metadata("design:type",String)],GitHubSettings.prototype,"OIDC_GITHUB_ISSUER_URL",void 0),__decorate([n(),__metadata("design:type",String)],GitHubSettings.prototype,"OIDC_GITHUB_CLIENT_ID",void 0),__decorate([n(),__metadata("design:type",String)],GitHubSettings.prototype,"OIDC_GITHUB_CLIENT_SECRET",void 0),__decorate([n(),__metadata("design:type",Array)],GitHubSettings.prototype,"OIDC_GITHUB_SCOPES",void 0);class GitHubProfileService{async discover(e){const t=e.construct(GitHubSettings);if(!t.OIDC_GITHUB)throw new Error("GitHubAuthIsNotEnabled");const o={provider:"github",providerProtocol:"oauth",providerURL:t.OIDC_GITHUB_ISSUER_URL,displayName:"GitHub Account",displayImageURL:"https://github.com/favicon.ico",providerConfiguration:{issuer:t.OIDC_GITHUB_ISSUER_URL,authorization_endpoint:"https://github.com/login/oauth/authorize",token_endpoint:"https://github.com/login/oauth/access_token",userinfo_endpoint:"https://api.github.com/user"}},r=await this.OpenIdProvider.findOrResolveExternalProvider(e,o),i=r.appID||t.OIDC_GITHUB_CLIENT_ID;if(!i)throw new a("OIDC_GITHUB_CLIENT_ID");const n=r.appSecret||t.OIDC_GITHUB_CLIENT_SECRET;if(!n)throw new a("OIDC_GITHUB_CLIENT_SECRET");return r.appID=i,r.appSecret=n,t.OIDC_GITHUB_SCOPES&&(r.scope=r.scope||t.OIDC_GITHUB_SCOPES.join(" ")),r}async getUserProfile(e,t,o){const r=new BearerClient(t.access_token),i=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const n=await r.get(o.providerConfiguration.userinfo_endpoint),a=await r.get("https://api.github.com/user/emails").then(e=>[]);let s=n.id,d=null,l=n.avatar_url,c=[];if(a&&a.length)for(const e of a)e.email&&e.primary&&e.verified&&(d=e.email,c.push({type:"email",value:e.email}));return{uid:s,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:n,userData:{},identities:c,username:n.login,domain:null,domainCertified:!1,email:d,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:n.name||n.login,displayImageURL:l,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:n.bio||null,homepage:n.blog||n.html_url||null,locale:i.locale}}}__decorate([m(),__metadata("design:type",ExternalProviderService)],GitHubProfileService.prototype,"OpenIdProvider",void 0);let Se=class GitHubOpenIdAuthController extends OpenIdAuthController{};__decorate([m(),__metadata("design:type",GitHubProfileService)],Se.prototype,"OpenIdProfile",void 0),Se=__decorate([A("/api/integration/github/auth")],Se);class MicrosoftGraphClient extends ExternalFetcher{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error("Access token can not be null or empty")}profile(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/me")}photo(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/me/photo").catch(e=>{const t=e.response.status;if(404===t||501===t)return null;throw new i(e,e.response.data,"Unable to resolve user photo")})}photoImage(e){return e?this.httpGetAsBuffer(`https://graph.microsoft.com/v1.0/me/photos/${e}/$value`):this.httpGetAsBuffer("https://graph.microsoft.com/v1.0/me/photo/$value")}photoImageDataURL(){return this.photo().then(e=>{if(!e)return Promise.resolve(null);const t=e["@odata.mediaContentType"],o=e.id;return this.photoImage(o).then(e=>`data:${t};charset=utf-8;base64,${e.toString("base64")}`)})}users(){return this.httpGetAsJson("https://graph.microsoft.com/v1.0/users")}getNextUsers(e){return this.httpGetAsJson(e)}}let Ee=class FileModel extends j{};Ee=__decorate([H("file")],Ee);class FileCollection extends z{constructor(){super(Ee)}}let Ce=class FileTokenModel extends j{};Ce=__decorate([H("file_token")],Ce);class FileTokenCollection extends q{constructor(){super(Ce)}}class WebFileService{async findTokenById(e,t){return(await e.resolve(FileTokenCollection)).getOne(t)}async findFileById(e,t){return(await e.resolve(FileCollection)).get(t)}async updateOne(e,t,o){return(await e.resolve(FileTokenCollection)).mergeOne(t,{title:o.title})}hash(e){const t=te("sha256").update(e).digest(),o=Buffer.concat([Buffer.from([18,32]),t]);return s.fromBytes(o)}async insertFromURL(e,t,o){const r=t.split("/"),i=r[r.length-1],n=await function fetchRemoteURL(e){return Q(e).then(async e=>({data:await e.buffer(),dataType:e.headers.get("content-type")||"application/octet-stream",dataLength:parseInt(e.headers.get("content-length")||"0")}))}(t),a=this.hash(n.data);return this.insertFromBuffer(e,a,n.data,Object.assign({},o,{originalname:i,originalurl:t,type:n.dataType}))}async insertFromBuffer(e,t,o,r){let{type:i,width:n,height:a,duration:s,ipfs:d}=r;const l=await e.resolve(FileCollection),c=await l.get(t);if(c)i=c.type,n=c.width,a=c.height,s=c.duration,d=c.ipfs;else{const e={type:i,byteLength:o.byteLength,data:o};if(r&&(e.width=r.width,e.height=r.height,e.duration=r.duration,e.ipfs=r.ipfs),!await l.add(t,e))throw new Error("UnableToSaveDataChunk")}return Object.assign({id:t,type:i||"application/octet-stream",byteLength:o.byteLength,width:n,height:a,duration:s,ipfs:d})}}class MicrosoftSettings extends e{}__decorate([n(),__metadata("design:type",Boolean)],MicrosoftSettings.prototype,"OIDC_MICROSOFT",void 0),__decorate([n(),__metadata("design:type",String)],MicrosoftSettings.prototype,"OIDC_MICROSOFT_ISSUER_URL",void 0),__decorate([n(),__metadata("design:type",String)],MicrosoftSettings.prototype,"OIDC_MICROSOFT_CLIENT_ID",void 0),__decorate([n(),__metadata("design:type",String)],MicrosoftSettings.prototype,"OIDC_MICROSOFT_CLIENT_SECRET",void 0),__decorate([n(),__metadata("design:type",Array)],MicrosoftSettings.prototype,"OIDC_MICROSOFT_SCOPES",void 0);class MicrosoftOpenIdService{constructor(){this.TrustedMicrosoftEmailDomains=["outlook.com","hotmail.com","live.cn","live.com","msn.com","passport.com","passport.net"]}async discover(e){const t=e.construct(MicrosoftSettings);if(!t.OIDC_MICROSOFT)throw new Error("MicrosoftAuthIsNotEnabled");const o={provider:"microsoft",providerProtocol:"openid",providerURL:t.OIDC_MICROSOFT_ISSUER_URL,displayName:"Microsoft Account",displayImageURL:"https://www.microsoft.com/favicon.ico"},r=await this.OpenIdProvider.findOrResolveExternalProvider(e,o),i=r.appID||t.OIDC_MICROSOFT_CLIENT_ID;if(!i)throw new a("OIDC_MICROSOFT_CLIENT_ID");const n=r.appSecret||t.OIDC_MICROSOFT_CLIENT_SECRET;if(!n)throw new a("OIDC_MICROSOFT_CLIENT_SECRET");return r.appID=i,r.appSecret=n,t.OIDC_MICROSOFT_SCOPES&&(r.scope=r.scope||t.OIDC_MICROSOFT_SCOPES.join(" ")),r}async getUserProfile(e,t,o){const r=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return console.log("provider not"),null;console.log("----------------------"),console.log("|      id_token      |"),console.log("======================"),console.log(r),console.log("======================");const i=new MicrosoftGraphClient(t.access_token),n=await i.profile().catch(()=>null);console.log("----------------------"),console.log("|      profile       |"),console.log("======================"),console.log(n),console.log("======================");const a=await i.photo();if(a){const t=await i.photoImage(a.id);if(t){const o=await e.resolve(WebFileService),r=o.hash(t),i=await o.insertFromBuffer(e,r,t,{type:a["@odata.mediaContentType"],width:a.width,height:a.height}).catch(e=>(console.log("err",e),console.log(`Unable to save profile image for microsoft user ${a.id}, displayImageURL will be NULL`),null));console.log("profile image",i)}}console.log("----------------------"),console.log("|      photo       |"),console.log("======================"),console.log(null),console.log("======================");let s=null,d=null,l=null,c=null,p=[],u=null,_=!1;if(n?(s=n.id,d=n.displayName):(s=r.oid||r.sub,d=r.name),r.preferred_username?l=r.preferred_username:n&&n.userPrincipalName&&(l=n.userPrincipalName),l){const e=l.split("@");2===e.length&&(c=e[1].toLowerCase())}if(r.email?u=r.email:n&&n.mail&&(u=n.mail),u){const t=u.split("@");if(2===t.length){this.TrustedMicrosoftEmailDomains.indexOf(t[1].toLowerCase())>=0&&(_=!0);const r=e.construct(WebFoundationSettings);for(const e of r.TRUSTED_EMAIL_PROVIDERS||[])if(("microsoft"===e.provider||e.provider===o.providerURL)&&e.domains.indexOf(t[1].toLowerCase())>=0){_=!0;break}}}return u&&_&&p.push({type:"email",value:u}),{uid:s,provider:o.provider,providerProtocol:o.providerProtocol,providerURL:o.providerURL,providerId:o._id.toHexString(),providerData:n,userData:{},identities:p,username:l,domain:c,domainCertified:!1,email:u,emailCertified:_,mobile:n&&n.mobilePhone,mobileCertified:!1,displayName:d,displayImageURL:null,familyName:n&&n.surname,givenName:n&&n.givenName,gender:null,dob:null,status:null,bio:n&&n.jobTitle,homepage:null,locale:n&&n.preferredLanguage}}}__decorate([m(),__metadata("design:type",ExternalProviderService)],MicrosoftOpenIdService.prototype,"OpenIdProvider",void 0);let we=class MicrosoftOpenIdAuthController extends OpenIdAuthController{};__decorate([m(),__metadata("design:type",MicrosoftOpenIdService)],we.prototype,"OpenIdProfile",void 0),we=__decorate([A("/api/integration/microsoft/auth")],we);let Oe=class DialogAttribute{constructor(e){this._name=e}beforeDecorate(e,t,o){return!0}get name(){return this._name}};function dialog(e){return oe(new Oe(e||""))}Oe=__decorate([v(),__metadata("design:paramtypes",[String])],Oe);class BotService extends o{}const Te=[];class BotStateService extends BotService{BotStateService(){this.history=Te,console.log("loading bot state from memory......")}async save(){console.log("saving bot state to memory......")}empty(){return!this.history.length}start(e){this.history.push([e,0,!0])}end(){for(let e=this.history.length-1;e>=0;e--){if(this.history[e][2])return void this.history.splice(e,this.history.length-e)}}isEnd(){const e=this.last();return!e||!!e[2]}push(e,t){this.history.push([e,0,t])}pop(){return this.history.pop()}last(){return this.history[this.history.length-1]}next(){const e=this.last();return e&&(e[1]=e[1]+1),e}restart(){const e=this.last();e&&(e[1]=0)}clear(){this.history.splice(0,this.history.length)}}class BotStateModel{}let be=class BotStateCollection extends K{constructor(){super(BotStateModel)}};be=__decorate([J("state"),__metadata("design:paramtypes",[])],be);class StorageBackedBotStateService extends BotStateService{StorageBackedBotStateService(e,t){this.id=e,this.model=t,this.history=this.model.stack||[]}static async[f](e,t){const o=await e.resolve(be),r={app:e.event.provider,bot:e.bot.id,chat:e.event.chat.id};e.event.sender&&(r.sender=e.event.sender.id);const i=T([r.app,r.bot,r.chat,r.sender]);let n=await o.getOne(i);if(n||(n=await o.insertOne(i,{...r,stack:[],state:{}})),!n)throw new Error("UnableCreateState");return d(e,"state",n.state),Reflect.construct(this,[i,n,e])}async save(){return(await this.resolve(be)).updateOne(this.id,{stack:this.history,state:this.parent.state}).then(e=>{e||this.logger.error({dialog:this.id},"Unable to save dialog state")})}}class DialogAction{}class DialogRouteAction extends DialogAction{constructor(e){super(),this.data=e}}class DialogResponseAction extends DialogAction{}class StartDialog extends DialogRouteAction{constructor(e,t){super(t),this.path=e}}class ReplaceDialog extends DialogRouteAction{constructor(e,t){super(t),this.path=e}}class RestartDialog extends DialogRouteAction{constructor(e){super(e)}}class EndDialog extends DialogRouteAction{constructor(e){super(e)}}class EndConversation extends DialogRouteAction{constructor(e){super(e)}}class ResetBot extends DialogRouteAction{constructor(e){super(e)}}class TextResponse extends DialogResponseAction{constructor(e,t){super(),this.text=e,this.format=t}}class DataResponse extends DialogResponseAction{constructor(e){super(),this.data=e}}class BotContext extends l{sendText(e,t){throw new c("sendText")}replyText(e,t){throw new c("replyText")}startDialog(e,t){return new StartDialog(e,t)}replaceDialog(e,t){return new ReplaceDialog(e,t)}restartDialog(e){return new ReplaceDialog(this.path,e)}endDialog(e){return new EndDialog(e)}endConversation(e){return new EndConversation(e)}resetBot(e){return new ResetBot(e)}}class BotSettings extends e{}const Be=new WeakMap;function GetBotContextData(e){return Be.get(e)}function SetBotContextData(e,t){Be.set(e,t)}var xe;let Ue=xe=class BotRouter extends o{search(e){throw new I(xe)}add(e){throw new I(xe)}};Ue=xe=__decorate([y()],Ue);class TypeRouterBindings extends u{}class BotDialogRouter extends Ue{search(e){return this._tree.search(e)}add(e,t){const o=re(e),r=o.getOwnAttributes(G),i=new Set;if(!r.length)throw new TypeError(`No @controller() attribute found on type ${e.prototype.constructor.name}`);for(const n of r){const r=n.path,a=this.createMiddleware(e),s=a.methods;for(const e of o.findTypes(e=>e.hasOwnProperties()).reverse())for(const o of e.getOwnProperties()){const e=o.key,d=e.toString();if(i.has(e))throw new TypeError(`Unable to override route for ${d}`);const l=s.length;let c=!1;const p=o.getOwnAttributes(M);for(const e of p)t&&t.beforeMiddleware&&!t.beforeMiddleware(n,e,o)||(this.addMiddleware(a,o,l),c=!0);for(const e of o.getOwnAttributes(Oe)){if(t&&t.beforeDialog&&!t.beforeDialog(n,e,o))continue;const i=e.name?r+e.name:r||"",s=this._tree.data(i);this.addDialog(a,o,s,l),c=!0}c&&(i.add(e),s.push(e))}}return this}createMiddleware(e){const t=new TypeRouterBindings;return t.performance=B,t.dataOf=GetBotContextData,t.type=e,t.methods=[],t.push(this.generateInitializerFn(t)),t}addMiddleware(e,t,o){e.push(this.generateMiddlewareFn(e,t,o))}addDialog(e,t,o,r){o.steps=o.steps||[],o.steps.push(this.generateDialogFn(e,t,r))}makeInvokeMethod(e,t){return"string"==typeof e?`.${e}`:"number"==typeof e?`[${e}]`:`[this.methods[${t}]]`}generateInitializerFn(e){return Function("ctx","next","if (!this.instance) {\n  this.performance.log(ctx, 'dialog', '[[new ' + this.type.prototype.constructor.name + '()]]');\n  this.instance = ctx.construct(this.type, true);\n}\nreturn next();").bind(e)}generateMiddlewareFn(e,t,o){const r=t.name,i=this.makeInvokeMethod(t.key,o);let n;return n=t.descriptor&&t.descriptor.value.length>2?`return this.performance.log(btx,'dialog','[${r}]'),this.instance${i}(btx, this.dataOf(btx), next);`:`return this.performance.log(btx,'dialog','[${r}]'),this.instance${i}(btx, next);`,Function("btx","next",n).bind(e)}generateDialogFn(e,t,o){const r=t.name,i=this.makeInvokeMethod(t.key,o);let n;n=t.descriptor&&t.descriptor.value.length>1?`return this.performance.log(btx,'dialog','${r}()'),this.instance${i}(btx, this.dataOf(btx));`:`return this.performance.log(btx,'dialog','${r}()'),this.instance${i}(btx);`;let a="";return a=e.length?"return btx.params=params,this.compose(this,btx,()=>{\n"+`  ${n}\n`+"});":n,Function("btx","params",a).bind(e)}}__decorate([S(),__metadata("design:type",p)],BotDialogRouter.prototype,"_tree",void 0);class DialogError extends i{}async function BotRoutingMiddleware(e,t){let o=e.path,r=e.pathIndex;B.log(e,"dialog"),e.logger.info(`[${e.identity.address}] --\x3e BOT ${o}[${r}]: ${e.message.text||"<redirect>"}`);const i=e.construct(BotDialogRouter).search(o);if(!(i&&i.data&&i.data.steps&&i.data.steps.length)){if(o.startsWith("/event/"))return console.log(`WARN: ${o} not found, end dialog and pop`),new EndDialog(GetBotContextData(e));throw new F({path:o},"DialogNotFound")}const n=i.data.steps,a=n[r];if(!a)return console.log("WARN: path index not found, end dialog and pop"),new EndDialog(GetBotContextData(e));const s=!!n[r+1];return a(e,i.params).then(e=>s?e instanceof DialogResponseAction?e:e instanceof DialogRouteAction?e:"string"==typeof e?new TextResponse(e):new DataResponse(e):e instanceof DialogRouteAction?e:new EndDialog(e),e=>Promise.reject(new DialogError(e,e.message)))}async function BotStateMiddleware(e,t){let o,r;B.log(e,"state");const i=await e.resolve(BotStateService);if(e.path)o=e.path,r=e.pathIndex,i.push(o);else{const e=i.last();e?(o=e[0],r=e[1]):(o="/",r=0)}return e.path=o||"/",e.pathIndex=r||0,t().then(e=>{if(e instanceof DialogRouteAction)if(e instanceof EndDialog){const t=i.isEnd();if(i.pop(),t)return new TextResponse(e.data)}else if(e instanceof StartDialog)i.next(),i.push(ee(o,e.path));else if(e instanceof ReplaceDialog)i.pop(),i.push(ee(o,e.path));else{if(!(e instanceof RestartDialog))return e instanceof ResetBot?(i.clear(),new TextResponse("ResetBot")):(i.pop(),i.end(),new TextResponse("EndConversation"));i.restart()}else i.next();return e})}class TelegramClient extends ExternalFetcher{constructor(e){if("string"!=typeof e&&!e)throw new Error("apiKey can not be null or empty");super({baseURL:`https://api.telegram.org/bot${e}`,headers:{"Content-Type":"application/json"}})}static[f](e,t){return Reflect.construct(this,t)}getMe(){return this.post("/getMe")}getUserProfilePhotos(e){const t={user_id:String(e)};return this.post(`/getUserProfilePhotos?${V(t)}`)}getFile(e){const t={file_id:e};return this.post(`/getFile?${V(t)}`)}sendMessage(e,t,o){return this.post("/sendMessage",{chat_id:e,text:t,parse_mode:"html",disable_web_page_preview:!0,...o})}editMessageText(e,t,o,r){return this.post("/editMessageText",{chat_id:e,message_id:t,text:o,parse_mode:"html",...r})}editMessageReplyMarkup(e,t,o){return this.post("/editMessageReplyMarkup",{chat_id:e,message_id:t,...o})}forwardMessage(e,t,o){return this.post("/forwardMessage",{chat_id:e,from_chat_id:t,message_id:o})}answerCallbackQuery(e,t,o,r){return this.post("/answerCallbackQuery",{callback_query_id:e,text:t,show_alert:o,url:r})}setWebhook(e,t,o,r){return this.post("/setWebhook",{url:e,certificate:t,max_connections:o,allowed_updates:r})}getWebhookInfo(){return this.post("/getWebhookInfo")}sendDocument(e,t,o){const r=new(require("form-data"));return r.append("chat_id",String(e)),o&&r.append("caption",o),r.append("document",t.data,{filename:t.filename,contentType:t.type}),this.post("/sendDocument",r,{headers:r.getHeaders()})}sendChatAction(e,t){return this.post("/sendChatAction",{chat_id:e,action:t})}sendInvoice(e,t,o,r,i={}){const n={chat_id:e,provider_token:t,start_parameter:r,need_name:!0,need_phone_number:!0,need_email:!0,...o,...i};return this.post("/sendInvoice",n)}answerPreCheckoutQuery(e,t){const o={pre_checkout_query_id:e,ok:!0};return t&&(o.ok=!1,o.message=t),this.post("/answerPreCheckoutQuery",o)}getChat(e){const t={chat_id:e};return this.post("/getChat",t)}exportChatInviteLink(e){const t={chat_id:e};return this.post("/exportChatInviteLink",t)}post(e,t,o){return _(()=>this.httpPost(e,t,o)).then(e=>e.data?{ok:e.data.ok?1:0,result:e.data.result}:{ok:0,errcode:400,message:"not a json response"},e=>({ok:0,errcode:e.errno,message:e.message}))}}class TelegramBotSettings extends e{}__decorate([n(),__metadata("design:type",Number)],TelegramBotSettings.prototype,"TELEGRAM_BOT_ID",void 0),__decorate([n(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_NAME",void 0),__decorate([n(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_DISPLAY_NAME",void 0),__decorate([n(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_TOKEN",void 0),__decorate([n(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_PAYMENT_PROVIDER_TOKEN",void 0),__decorate([n(),__metadata("design:type",String)],TelegramBotSettings.prototype,"TELEGRAM_BOT_SECRET_KEY",void 0),__decorate([n(),__metadata("design:type",Number)],TelegramBotSettings.prototype,"TELEGRAM_BOT_DIALOG_TIMEOUT_IN_SECONDS",void 0);class Telegram extends BotService{get client(){const e=this.construct(TelegramBotSettings);return new TelegramClient(e.TELEGRAM_BOT_SECRET_KEY)}setupWebhook(e){return this.client.getWebhookInfo().then(t=>t.ok&&t.result.url.startsWith(e)?(this.logger.info({url:t.result.url},"Telegram webhook is up to date"),t):(this.logger.info({url:e},"Updating Telegram Webhook url"),this.client.setWebhook(e).then(t=>(this.logger.info({result:t},`Telegram webhook updated to: ${e}`),t)))).catch(e=>{throw this.logger.error(e),new i(e,"Unable to update Telegram webhook url")})}getMe(){return this.client.getMe()}sendText(e,t,o){return this.client.sendMessage(e,t,o)}sendInvoice(e,t,o,r){return this.client.sendInvoice(e,t,o,r)}sendCode(e,t,o){return this.client.sendMessage(e,`<code>${t}</code>`,{parse_mode:"html",...o})}confirmInvoice(e,t){return this.client.answerPreCheckoutQuery(e,t)}getChat(e){return this.client.getChat(e)}exportChatInviteLink(e){return this.client.exportChatInviteLink(e)}}async function BotErrorMiddleware(e,t){return t().catch(t=>{const o=e.construct(Telegram);return e.logger.error(t,{bot:e.bot.username,path:`${e.path}[${String(e.pathIndex)}]`,identity:e.identity},"BotError"),o.sendCode(e.event.chat.id,`${t.name}: ${t.message}`,{reply_to_message_id:e.message.id}).then(()=>void 0,()=>void 0)})}__decorate([E(),__metadata("design:type",Object),__metadata("design:paramtypes",[])],Telegram.prototype,"client",null);const De=new WeakSet;async function BotEventMiddleware(e,t){if(!De.has(e)&&(De.add(e),!e.path)){const t=await e.resolve(BotStateService);if(console.log("msg",e.message),e.message.command){e.logger.info(`[${e.identity.address}] --\x3e CMD ${e.message.text}`);const{command:o,commandArgs:r}=e.message;t.start(o),SetBotContextData(e,r)}else"event/callback"===e.event.type?e.path="/"+e.event.type:"event/checkout"===e.event.type?e.path="/"+e.event.type:"event/payment"===e.event.type?e.path="/"+e.event.type:t.empty()&&t.start("/")}return t()}async function BotLoggingMiddleware(e,t){let o=e.identity.profile?e.identity.profile.displayName:"Guest";return e.logger.info(`[${e.identity.address}] --\x3e ${o}: ${e.message.text||`[${e.event.type}]`}`),t()}const Re=new WeakMap;class Bot extends o{Bot(){this.addMiddleware(BotErrorMiddleware),this.addMiddleware(BotLoggingMiddleware),this.addMiddleware(BotEventMiddleware),this.addMiddleware(BotStateMiddleware),this.addMiddleware(BotRoutingMiddleware)}async route(e){let t=Re.get(e)||0;return t?(t++,Re.set(e,t),new Promise((t,o)=>{setImmediate(()=>{this.middleware.compose(this,e).then(t,o)})})):(t=1,Re.set(e,t),this.middleware.compose(this,e))}async invoke(e){const t=await this.route(e);if(t instanceof DialogRouteAction)return e.path="",SetBotContextData(e,t.data),this.invoke(e);const o=e.getAgent(BotStateService);return o&&await o.save(),t}addMiddleware(e){this.middleware.push(e)}addDialog(e){this.dialog.add(e,this.handler)}addDialogs(e){for(const t of Object.keys(e))this.addDialog(e[t])}}__decorate([m(),__metadata("design:type",BotDialogRouter)],Bot.prototype,"dialog",void 0),__decorate([m(),__metadata("design:type",class BotDialogEventHandler extends BotService{beforeMiddleware(e,t,o){const r=this.makeMiddlewareSignature(o);return this.logger.debug(`(*) ${e.path} => ${o.declaringType.name}::${o.name}(${r})`),!0}beforeDialog(e,t,o){const r=this.makeMethodSignature(o),i=e.path+t.name;return this.logger.debug(`BOT ${i} => ${o.declaringType.name}::${o.name}(${r})`),!0}makeMiddlewareSignature(e){return e.descriptor&&e.descriptor.value.length>2?"ctx, data, next":"ctx, next"}makeMethodSignature(e){return e.descriptor&&e.descriptor.value.length>1?"ctx, data":"ctx"}})],Bot.prototype,"handler",void 0),__decorate([S(),__metadata("design:type",u)],Bot.prototype,"middleware",void 0);class BotMessage{get id(){throw new g("id")}get private(){throw new g("private")}get text(){throw new g("text")}get command(){throw new g("command")}get commandArgs(){throw new g("commandArgs")}}class BotIdentity extends h{}class BotEvent{}class TelegramBotEventFactory{static normalizeUpdate(e){const t=e.channelData||e;let o,r,n,a,s,d,l,c,p,u=[];if(t.message)(a=t.message).text?n="message/text":a.voice?n="message/voice":a.photo?n="message/photo":a.document?n="message/document":a.location?n="message/location":a.sticker?n="message/sticker":a.new_chat_participant?(n="event/join_chat",s=a.new_chat_participant):a.left_chat_member?(n="event/left_chat",s=a.left_chat_participant):n=a.new_chat_title?"event/new_chat_title":a.new_chat_photo?"event/new_chat_photo":a.successful_payment?"event/payment":"message";else if(t.callback_query)n="event/callback",p=a=t.callback_query.message,c=t.callback_query.data;else if(t.channel_post)n="event/post",a=t.channel_post;else if(t.edited_message)n="event/edit_message",a=t.edited_message;else if(t.edited_message)n="event/edit_post",a=t.edited_channel_post;else{if(!t.pre_checkout_query)throw new i(t,"Unknown message type");{const e=t.pre_checkout_query;o=e.id,n="event/checkout";const i=e.from;d={id:i.id,type:"private",name:i.username,displayName:i.last_name?i.first_name+" "+i.last_name:i.first_name,isPrivate:!0,isGroup:!1,isChannel:!1},a=e,c=e.invoice_payload,r=new Date}}if(a){o||(o=a.message_id);const e=a.chat;!d&&e&&(d={id:e.id,type:e.type,name:e.username,displayName:e.title||(e.last_name?e.first_name+" "+e.last_name:e.first_name),isPrivate:"private"===e.type,isGroup:"group"===e.type,isChannel:"channel"===e.type}),s||(s=a.from),c||(c=a.text,u=a.entities),p||(delete(p=Object.assign({},a)).message_id,delete p.chat,delete p.from,delete p.date,delete p.text,delete p.entities),a.edit_date?r=new Date(1e3*a.edit_date):a.date&&(r=new Date(1e3*a.date))}if(s){let e=`${s.first_name}`;s.last_name&&(e+=` ${s.last_name}`),l={id:s.id,name:s.username,firstName:s.first_name,lastName:s.last_name,displayName:e,locale:s.language_code,bot:s.is_bot}}return[o,n,r||new Date,d,l,"telegram",t,void 0,p,c,u]}}class TelegramBotEvent extends BotEvent{constructor(e,t,o,r,i,n,a,s,d,l,c){super(),this.id=e,this.type=t,this.timestamp=o,this.chat=r,this.sender=i,this.provider=n,this.providerData=a,this.message=s,this.data=d,this.text=l,this.textEntities=c}static[f](e,t){return Reflect.construct(this,TelegramBotEventFactory.normalizeUpdate(t[0]))}}class BotProfile{}class TelegramBotIdentity extends BotIdentity{constructor(e,t,o,r,i,n){super(),this.id=e,this.address=t,this.timezone=o,this.locale=r,this.user=i,this.profile=n}static[f](e){const t=e.getAgentOrThrow(BotProfile),o=e.getAgentOrThrow(BotEvent);let r,i,n,a,s,d;if(r=String(o.chat.id),i="/telegram/bot/"+t.id+"/chat/"+o.chat.id,o.sender){const t=T([o.sender.id,"3fdeba596a7d938a05c38daf"]).toHexString();n=t,a={_id:t,id:o.sender.id,name:o.sender.name,displayName:o.sender.displayName,displayImageURL:""},d=o.sender.locale||e.settings.LOCALE}else d=e.settings.LOCALE;return s=e.settings.TIMEZONE,Reflect.construct(this,[r,i,s,d,n,a])}}function buildCommand(e){let t,o=[];if(e.text&&Array.isArray(e.textEntities))for(const r of e.textEntities)if("bot_command"===r.type){t=e.text.slice(r.offset,r.offset+r.length);const i=e.text.slice(r.offset+r.length).trim();o=i?i.split(" "):[]}return[t,o]}class TelegramBotMessage extends BotMessage{constructor(){super();const e=C(new.target,arguments);if(!e)throw new Error("NotAllowedToCreateTelegramBotEventMessage");const t=e.getAgent(TelegramBotEvent);if(!t)throw new Error("NotAllowedToCreateTelegramBotEventMessageWithoutTelegramBotEvent");d(this,"event",t)}get id(){return this.event.id}get private(){return this.event.chat.isPrivate}get text(){return this.event.text}get command(){const[e,t]=buildCommand(this.event);return d(this,"commandArgs",t),d(this,"command",e)}get commandArgs(){const[e,t]=buildCommand(this.event);return d(this,"command",e),d(this,"commandArgs",t)}}class TelegramBotContext extends BotContext{sendText(e,t){return this.telegram.sendText(t||this.event.chat.id,e)}sendTextWithAction(e,t,o){return this.telegram.sendText(o||this.event.chat.id,e,{reply_markup:{inline_keyboard:[[{text:"yes",callback_data:"cb123456"}]]}})}replyText(e,t,o){return this.telegram.sendText(o||this.event.chat.id,e,{reply_to_message_id:t||this.message.id})}sendTextWithKeyboard(){}}__decorate([m(),__metadata("design:type",BotProfile)],TelegramBotContext.prototype,"bot",void 0),__decorate([m(),__metadata("design:type",TelegramBotIdentity)],TelegramBotContext.prototype,"identity",void 0),__decorate([m(),__metadata("design:type",TelegramBotEvent)],TelegramBotContext.prototype,"event",void 0),__decorate([m(),__metadata("design:type",TelegramBotMessage)],TelegramBotContext.prototype,"message",void 0),__decorate([m(),__metadata("design:type",Telegram)],TelegramBotContext.prototype,"telegram",void 0);class TelegramBot extends Bot{}class TelegramBotProfile extends BotProfile{constructor(e,t,o,r){super(),this.id=e,this.username=t,this.displayName=o,this.displayImageURL=r}static[f](e,t){return Reflect.construct(this,t)}}let Le=class TelegramBotController extends WebFoundationController{constructor(){super(...arguments),this.token=this.telegramBotSettings.TELEGRAM_BOT_TOKEN}async setup(e){const t=await e.resolve(Telegram),o=re(this.constructor).getOwnAttributes(G)[0];if(!o)throw new Error("not found bot route");const r=e.publicURL||this.settings.PUBLIC_URL;if(!r)throw new Error("unable to resolve public url");const i=Y(r,`${o.path}/update/${this.token}`),n=await t.setupWebhook(i);return{bot:await t.getMe(),hook:n}}async update(e){if(!e.params.token)throw new U("Missing bot token for telegram");if(this.token!==e.params.token)throw new U("Invalid bot token");const t=this.telegramBotSettings.TELEGRAM_BOT_ID,o=this.telegramBotSettings.TELEGRAM_BOT_NAME,r=this.telegramBotSettings.TELEGRAM_BOT_DISPLAY_NAME||e.settings.NAME;return e.json().then(i=>(console.log("UPDATE = ",JSON.stringify(i,null,2)),e.resolve(TelegramBotProfile,[t,o,r]).then(t=>e.resolve(TelegramBotEvent,[i]).then(t=>(console.log("EVENT = ",t),e.resolve(TelegramBotContext).then(e=>this.bot.invoke(e))))))).then(t=>{t&&e.logger.trace("ignore bot response")}).catch(t=>{e.logger.error(t,"Unable to parse telegram request")})}};__decorate([m(),__metadata("design:type",TelegramBotSettings)],Le.prototype,"telegramBotSettings",void 0),__decorate([m(TelegramBot),__metadata("design:type",Bot)],Le.prototype,"bot",void 0),__decorate([L("GET","/setup"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],Le.prototype,"setup",null),__decorate([L("POST","/update/:token"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],Le.prototype,"update",null),Le=__decorate([A("/api/integration/telegram/bot")],Le);class WechatBotSettings extends e{}__decorate([n(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_ID",void 0),__decorate([n(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_NAME",void 0),__decorate([n(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_DISPLAY_NAME",void 0),__decorate([n(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_TOKEN",void 0),__decorate([n(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_SECRET_TOKEN",void 0),__decorate([n(),__metadata("design:type",String)],WechatBotSettings.prototype,"WECHAT_BOT_SECRET_KEY",void 0),__decorate([n(),__metadata("design:type",Number)],WechatBotSettings.prototype,"WECHAT_BOT_DIALOG_TIMEOUT_IN_SECONDS",void 0);let Ae=class WechatBotController extends WebFoundationController{async checkSender(e,t){const o=e.construct(WechatBotSettings),r=[e.query.nonce,e.query.timestamp,o.WECHAT_BOT_SECRET_TOKEN].join(""),i=te("sha1");i.update(r);const n=i.digest().toString("hex");return console.log("current",n),console.log("giving",e.query.signature),console.log("params",e.params),console.log("query",e.query),console.log("body",await e.text()),"GET"===e.method&&n!==e.query.signature?(e.logger.error("InvalidSignature"),""):t()}async verify(e){return e.query.echostr}async update(e){return`\n<xml>\n  <ToUserName><![CDATA[ostx3t918MejplFTMcWTD1erZkHY]]></ToUserName>\n  <FromUserName><![CDATA[gh_6c8b7f4f2e73]]></FromUserName>\n  <CreateTime>${Date.now()}</CreateTime>\n  <MsgType><![CDATA[text]]></MsgType>\n  <Content><![CDATA[你好]]></Content>\n</xml>`}};__decorate([W(),__metadata("design:type",Function),__metadata("design:paramtypes",[Object,Function]),__metadata("design:returntype",Promise)],Ae.prototype,"checkSender",null),__decorate([L("GET","/update/:token"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],Ae.prototype,"verify",null),__decorate([L("POST","/update/:token"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],Ae.prototype,"update",null),Ae=__decorate([A("/api/integration/wechat/bot")],Ae);let Ne=class WebFileController{async token(e){const t=await this.WebFile.findTokenById(e,e.params.id);if(!t)throw new F;const o=s.fromBytes(T(t.file)),r=e.headers.get("if-none-match");if(r&&r===o)e.body=null,e.status=304;else{const r=await this.WebFile.findFileById(e,t.file);if(!r)throw new F;e.body=r.data,e.setHeader("etag",o),e.setHeader("content-type",r.type),e.setHeader("content-length",`${r.byteLength}`),e.status=200}}};__decorate([m(),__metadata("design:type",WebFileService)],Ne.prototype,"WebFile",void 0),__decorate([L("GET","/token/:id"),__metadata("design:type",Function),__metadata("design:paramtypes",[Object]),__metadata("design:returntype",Promise)],Ne.prototype,"token",null),Ne=__decorate([A("/api/file")],Ne);class WebFoundation extends ${WebFoundation(){this.addController(de),this.addController(se),this.addController(fe),this.addController(we),this.addController(Se),this.addController(Ie),this.addController(ve),this.addController(ye),this.addController(Ne),this.addController(Le),this.addController(Ae)}}export{de as AuthenticationController,ne as AuthenticationService,AuthenticationSettings,se as BasicAuthenticationController,fe as BitBucketOpenIdAuthController,BitBucketSettings,Bot,BotContext,BotEvent,BotIdentity,BotMessage,BotSettings,be as BotStateCollection,BotStateModel,BotStateService,CurrentUser,Oe as DialogAttribute,ExternalFetcher,ExternalProviderService,ExternalUserService,Se as GitHubOpenIdAuthController,GitHubSettings,Ie as GitLabOpenIdAuthController,ve as GoogleOpenIdAuthController,we as MicrosoftOpenIdAuthController,SessionModel,ie as SessionService,StorageBackedBotStateService,Telegram,TelegramBot,TelegramBotContext,Le as TelegramBotController,TelegramBotEvent,TelegramBotIdentity,TelegramBotMessage,TelegramBotSettings,UserCollection,Ne as WebFileController,WebFileService,WebFoundation,WebFoundationService,WebFoundationSettings,Ae as WechatBotController,ye as WeiboOpenIdAuthController,dialog};
//# sourceMappingURL=index.mjs.map
